#pragma once

#include <plugin/ARGBaseDispatchableObject.h>
#include <plugin/IARGPluginEnvironment.h>
#include <GL/glut.h>
#include <MMDModel.h>
#include <plugin/ARGMutex.h>
#include <plugin/ARGBaseWorker.h>
#include <IDataMutex.h>
#include "BasicClock.h"

class ExternalClock;
class MMDObjectFactory;

/**
* MMDIuWFNg̎łB
*/
class MMDObject : public ARGBaseDispatchableObject
{
public:

	/**
	* \z܂B
	*/
	MMDObject(MMDObjectFactory* pFactory, IARGPluginEnvironment* pEnv, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~MMDObject();

	/**
	* ǂݏo܂B
	*/
	HRESULT Load(const char* pmdPath, const char* vmdPath, double scale);

	/**
	* `悵܂B
	*/
	STDMETHODIMP Draw();

	/**
	* AChȌsȂ܂B
	*/
	STDMETHODIMP OnIdle();

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP Invoke(DISPID dispIdMember, REFIID riid, LCID  lcid, WORD  wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, unsigned int *puArgErr);

	/**
	* pNbNݒ肵܂B
	*/
	STDMETHODIMP SetSyncClock(IARGSyncClock* pClock);

	/**
	* pNbN擾܂B
	*/
	STDMETHODIMP GetSyncClock(IARGSyncClock** ppClock);

	/**
	* Cxg擾܂B
	*/
	STDMETHODIMP GetEventCount(int* pCount);

	/**
	* Cxg擾܂B
	*/
	STDMETHODIMP GetEvent(int index, char* pEventName, int maxLen, int* pLen);

	/**
	* CxgfBXpb`ǉ܂B
	*/
	STDMETHODIMP AddEventDispatcher(const char* name, IARGEventDispatcher* pDispatcher);

	/**
	* CxgfBXpb`폜܂B
	* pDispatcherNULL̏ꍇnameɊւ邷ׂẴfBXpb`폜܂B
	*/
	STDMETHODIMP RemoveEventDispatcher(const char* name, IARGEventDispatcher* pDispatcher);

private:

	/**
	* ITypeInfo𐶐܂B
	*/
	HRESULT CreateTypeInfo();

	/**
	* [J[XV܂B
	*/
	HRESULT RestartUpdateWorker();

	/**
	* [J[~܂B
	*/
	void StopUpdateWorker();

	/**
	* [J[Jn܂B
	*/
	HRESULT StartUpdateWorker();

	/**
	* eNX`ǂݍݗp̃NXłB
	*/
	class TextureProviderImpl : public IMMDTextureProvider
	{
	public:

		/**
		* \z܂B
		*/
		TextureProviderImpl(const char* pmdPath);

		/**
		* j܂B
		*/
		virtual ~TextureProviderImpl();

		/**
		* ǂݏo܂B
		*/
		HRESULT Load(const char* filename, TEXTURE_DESC* pDesc);

	private:

		/**
		* x[XpXێ܂B
		*/
		string m_basePath;

	};

	/**
	* XV[J[łB
	*/
	class UpdateWorker : public ARGBaseWorker, public IDataMutex
	{
	public:

		/**
		* \z܂B
		*/
		UpdateWorker(MMDModel* pModel, IClock* pClock, float fps, float offset);

		/**
		* j܂B
		*/
		virtual ~UpdateWorker();

		/**
		* s܂B
		* G[̓XbĥȂ΂Ȃ܂B
		*/
		STDMETHODIMP Invoke();

		/**
		* NeBJZNVJn܂B
		*/
		void Begin();

		/**
		* NeBJZNVI܂B
		*/
		void End();

		/**
		* Ōɏt[ԍ擾܂B
		*/
		HRESULT GetLastFrame(float* pLastFrame);

		/**
		* ~܂B
		*/
		HRESULT Stop(HANDLE* hExitEvent);

		/**
		* AChԂł邱Ƃݒ肵܂B
		*/
		void SetIdle();

	private:

		/**
		* fێ܂B
		*/
		MMDModel* m_pModel;

		/**
		* NbNێ܂B
		*/
		IClock* m_pClock;

		/**
		* t[[gێ܂B
		*/
		float m_fFps;

		/**
		* ItZbgێ܂B
		*/
		float m_fOffset;

		/**
		* Ōɏt[ێ܂B
		*/
		float m_fLastFrame;

		/**
		* ClockpMutexێ܂B
		*/
		ARGMutex m_clockMutex;

		/**
		* fpMutexێ܂B
		*/
		ARGMutex m_modelMutex;

		/**
		* Cxgێ܂B
		*/
		HANDLE m_hIdleEvent;

	};

	/**
	* VMDǂݍ݂̃[J[łB
	*/
	class LoadVMDWorker : public ARGBaseWorker
	{
	public:

		/**
		* \z܂B
		*/
		LoadVMDWorker(MMDModel* pModel, const char* path, vector<IARGEventDispatcher*>& disps);

		/**
		* j܂B
		*/
		virtual ~LoadVMDWorker();

		/**
		* s܂B
		* G[̓XbĥȂ΂Ȃ܂B
		*/
		STDMETHODIMP Invoke();

	private:

		/**
		* fێ܂B
		*/
		MMDModel* m_pModel;

		/**
		* VMD̃pXێ܂B
		*/
		string m_vmdPath;

		/**
		* VMDt@C̓ǂݍ݊pDispatcherێ܂B
		*/
		vector<IARGEventDispatcher*> m_vmdLoadedDisps;

	};

	/**
	* t@Ngێ܂B
	*/
	MMDObjectFactory* m_pFactory;

	/**
	* vOCsێ܂B
	*/
	IARGPluginEnvironment* m_pEnv;

	/**
	* FPSێ܂B
	*/
	float m_fFps;

	/**
	* ItZbgێ܂B
	*/
	float m_fOffset;

	/**
	* t@CpXێ܂B(PMDt@C)
	*/
	string m_pmdPath;

	/**
	* t@CpXێ܂B(VMDt@C)
	*/
	string m_vmdPath;

	/**
	* MMDfێ܂B
	*/
	MMDModel* m_pModel;

	/**
	* [J[ێ܂B
	*/
	UpdateWorker* m_pUpdateWorker;

	/**
	* NbNێ܂B
	*/
	BasicClock m_clock;

	/**
	* pNbNێ܂B
	*/
	IARGSyncClock* m_pClock;

	/**
	* ONbNێ܂B
	*/
	ExternalClock* m_pExtClock;

	/**
	* VMDt@C̓ǂݍ݊pDispatcherێ܂B
	*/
	vector<IARGEventDispatcher*> m_vmdLoadedDisps;

	/**
	* nhǗpMutexێ܂B
	*/
	ARGMutex m_vmdLoadedDispsMutex;

};
