#include "StdAfx.h"
#include "TestPatternDetector.h"

// JE^̍ő吔`܂B
#define MAX_TICK_COUNT	16

// \z܂B
TestPatternDetector::TestPatternDetector(HRESULT* phr)
{
	;
}

// j܂B
TestPatternDetector::~TestPatternDetector()
{
	for(vector<TestPattern*>::size_type i = 0; i < m_patterns.size(); i ++) {
		TestPattern* pPat = m_patterns[i];
		pPat->Release();
	}
	m_patterns.clear();
}

// p[^^Cv̌␔擾܂B
STDMETHODIMP TestPatternDetector::GetParameterTypeCandidateCount(int* pCount)
{
	if(pCount == NULL) {
		return E_POINTER;
	}
	*pCount = 1;
	return S_OK;
}

// p[^^Cv̌₲Ƃ̈̐擾܂B
STDMETHODIMP TestPatternDetector::GetParameterTypeCount(int candIndex, int* pCount)
{
	if(pCount == NULL) {
		return E_POINTER;
	}
	if(candIndex == 0) {
		*pCount = 1;
		return S_OK;
	}else{
		return E_INVALIDARG;
	}
}

// p[^^Cv̌₲Ƃ̈^Cv擾܂B
STDMETHODIMP TestPatternDetector::GetParameterType(int candIndex, int index, VARTYPE* pVarType)
{
	if(pVarType == NULL) {
		return E_POINTER;
	}
	if(candIndex == 0) {
		if(index == 0) {
			*pVarType = VT_I4;
			return S_OK;
		}else{
			return E_INVALIDARG;
		}
	}else{
		return E_INVALIDARG;
	}
}

// IuWFNg𐶐܂B
STDMETHODIMP TestPatternDetector::Create(VARIANT* pVars, int varCount, IARGPattern** ppObject)
{
	if(pVars == NULL || ppObject == NULL) {
		return E_POINTER;
	}
	if(varCount = 1) {
		int i = pVars[0].intVal;
		HRESULT hr = S_OK;
		TestPattern* pPat = new TestPattern(& hr);
		if(FAILED(hr)) {
			delete pPat;
			pPat = NULL;
			return hr;
		}

		pPat->AddRef();
		m_patterns.push_back(pPat);

		*ppObject = pPat;
		return S_OK;
	}else{
		return E_INVALIDARG;
	}
}

// ܂B
STDMETHODIMP TestPatternDetector::Process(int width, int height, unsigned char* pData)
{
	for(vector<TestPattern*>::iterator it = m_patterns.begin(); it != m_patterns.end(); it ++) {
		TestPattern* pPat = *it;
		HRESULT hr = pPat->Process(width, height, pData);
		if(FAILED(hr)) {
			return hr;
		}
	}
	return S_OK;
}

// \z܂B
TestPatternDetector::TestPattern::TestPattern(HRESULT* phr)
{
	m_iTickCount = 0;
	HRESULT hr = CreateTypeInfo();
	if(FAILED(hr)) {
		*phr = hr;
		return;
	}
}

// j܂B
TestPatternDetector::TestPattern::~TestPattern()
{
	for(vector<IARGPatternObserver*>::size_type i = 0; i < m_observers.size(); i ++) {
		IARGPatternObserver* pObserver = m_observers[i];
		pObserver->Release();
	}
	m_observers.clear();
}

// ϊs擾܂B
STDMETHODIMP TestPatternDetector::TestPattern::GetTranslate(PATTERN_TRANSLATE* pTrans)
{
	if(pTrans == NULL) {
		return E_POINTER;
	}
	ZeroMemory(pTrans, sizeof(PATTERN_TRANSLATE));
	return S_OK;
}

// p^[Ďǉ܂B
STDMETHODIMP TestPatternDetector::TestPattern::AddPatternObserver(IARGPatternObserver* pObserver)
{
	if(pObserver == NULL) {
		return E_POINTER;
	}
	m_observers.push_back(pObserver);
	pObserver->AddRef();
	return S_OK;
}

// p^[Ď폜܂B
STDMETHODIMP TestPatternDetector::TestPattern::RemovePatternObserver(IARGPatternObserver* pObserver)
{
	if(pObserver == NULL) {
		return E_POINTER;
	}
	for(vector<IARGPatternObserver*>::iterator it = m_observers.begin(); it != m_observers.end(); it ++) {
		IARGPatternObserver* pObs = *it;
		if(pObs == pObserver) {
			m_observers.erase(it);
			pObserver->Release();
			return S_OK;
		}
	}
	return S_FALSE;
}

// IDispatch̎B
STDMETHODIMP TestPatternDetector::TestPattern::Invoke(DISPID dispIdMember, REFIID riid, LCID  lcid, WORD  wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, unsigned int *puArgErr)
{
	return S_OK;
}

// ܂B
HRESULT TestPatternDetector::TestPattern::Process(int width, int height, unsigned char* pData)
{
	PATTERN_STATE state = PATTERN_CHANGED;
	if(m_iTickCount == 0) {
		m_iTickCount ++;
		state = PATTERN_FOUND;
	}else if(m_iTickCount == MAX_TICK_COUNT) {
		m_iTickCount = 0;
		state = PATTERN_LOST;
	}else{
		m_iTickCount ++;
		if(m_iTickCount % 4 != 0) {
			return S_OK;
		}
	}
	for(vector<IARGPatternObserver*>::iterator it = m_observers.begin(); it != m_observers.end(); it ++) {
		IARGPatternObserver* pObs = *it;
		HRESULT hr = pObs->DispatchChanged(state);
		if(FAILED(hr)) {
			return hr;
		}
	}
	return S_OK;
}

// ITypeInfo𐶐܂B
HRESULT TestPatternDetector::TestPattern::CreateTypeInfo()
{
	ARGTypeInfo* pTypeInfo = new ARGTypeInfo(IID_IARGPattern);

	m_pTypeInfo = pTypeInfo;
	return S_OK;
}
