#pragma once

#include "../common/AbstractProperty.h"
#include "../plugin/IARGObjectFactory.h"

class ARWindow;

/**
* AR̃OtBbN\NXB
*/
class ARGraphics
{
public:

	/**
	* \z܂B
	*/
	ARGraphics(ARWindow* pOwner);

	/**
	* j܂B
	*/
	virtual ~ARGraphics();

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;

	/**
	* OtBbN`悵܂B
	*/
	virtual HRESULT Draw() = 0;

	/**
	* IJSObject擾܂B
	*/
	virtual IJSObject* GetJSObject() = 0;

	/**
	* qǉ܂B
	*/
	HRESULT AddChild(ARGraphics* pGraphics, int* pIndex);

	/**
	* q폜܂B
	*/
	HRESULT RemoveChild(int index);

	/**
	* qXg擾܂B
	*/
	HRESULT GetChildren(vector<ARGraphics*>& children);

	/**
	* qXg擾܂B
	*/
	HRESULT GetChildren(IArrayProperty** ppProp);

	/**
	* \ׂǂ擾܂B
	*/
	virtual HRESULT IsVisible(bool* pVisible);

	/**
	* \ׂǂݒ肵܂B
	*/
	virtual HRESULT SetVisible(bool visible);

	/**
	* vpeB擾܂B
	*/
	HRESULT GetProperty(INamedProperty** ppProp);

	/**
	* I[i[EBhE擾܂B
	*/
	HRESULT GetOwner(ARWindow** ppOwner);

	/**
	* IuWFNgt@Ng̒ǉʒm܂B
	*/
	virtual HRESULT NotifyObjectFactoryAdded(const char* name, IARGObjectFactory* pFactory);

	/**
	* ACh̏sȂ܂B
	*/
	virtual HRESULT OnIdle();

protected:

	/**
	* q`悵܂B
	*/
	HRESULT DrawChildren();

	/**
	* qɑ΂ăIuWFNgt@Ng̒ǉʒm܂B
	*/
	HRESULT NotifyObjectFactoryAddedForChildren(const char* name, IARGObjectFactory* pFactory);

	/**
	* ACh̏sȂ܂B
	*/
	HRESULT OnIdleForChildren();

	/**
	* vpeB𐶐܂B
	*/
	virtual HRESULT CreateProperty(INamedProperty** ppProp);

	/**
	* qێ܂B
	*/
	vector<ARGraphics*> m_children;

	/**
	* \ׂǂێ܂B
	*/
	bool m_visible;

	/**
	* vpeBێ܂B
	*/
	INamedProperty* m_pProp;

	/**
	* vpeB̎B
	*/
	class GraphicsPropertyImpl : public AbstractNamedProperty
	{
	public:

		/**
		* \z܂B
		*/
		GraphicsPropertyImpl(ARGraphics* pOwner);

		/**
		* j܂B
		*/
		virtual ~GraphicsPropertyImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();

		/**
		* o܂B
		*/
		virtual HRESULT Init();

	protected:
		
		/**
		* bool̃vpeB擾܂B
		*/
		virtual HRESULT GetBoolProperty(const char* name, bool* pValue);
		
		/**
		* bool̃vpeBݒ肵܂B
		*/
		virtual HRESULT SetBoolProperty(const char* name, bool value);

	private:

		/**
		* I[i[ێ܂B
		*/
		ARGraphics* m_pOwner;

	};

	/**
	* qXgB
	*/
	class ChildList : public AbstractArrayProperty
	{
	public:

		/**
		* \z܂B
		*/
		ChildList(ARGraphics* pOwner);

		/**
		* j܂B
		*/
		virtual ~ChildList();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* vpeB擾܂B
		*/
		HRESULT GetPropertyCount(int* pCount);

	protected:
			
		/**
		* vpeB擾܂B
		*/
		HRESULT GetPropertyDesc(int index, PROPERTY_DESC* pDesc);
				
		/**
		* IJSObject̃vpeB擾܂B
		*/
		HRESULT GetJSObject(int index, IJSObject** ppValue);

	private:

		/**
		* I[i[ێ܂B
		*/
		ARGraphics* m_pOwner;
	};

private:

	/**
	* I[i[EBhEێ܂B
	*/
	ARWindow* m_pOwner;

	/**
	* qXgێ܂B
	*/
	ChildList* m_pChildList;
};