#include "StdAfx.h"
#include "ARPattern.h"
#include <AR/ar.h>

// `łꍇ̃p^[ID
const int UNDEFINED_PATTERN = -1;

// \z܂B
ARPattern::ARPattern(void)
{
	m_patternId = UNDEFINED_PATTERN;
}

// j܂B
ARPattern::~ARPattern(void)
{
	if(m_patternId != UNDEFINED_PATTERN) {
		arFreePatt(m_patternId);
		m_patternId = UNDEFINED_PATTERN;
	}
}

// }[J[܂B
HRESULT ARPattern::Process(ARMarkerInfoContainer* pMarkerInfoC, int size)
{
	if(m_patternId == UNDEFINED_PATTERN) {
		return S_OK;
	}

	ARMarkerInfo* pMarkerInfo = (ARMarkerInfo*) pMarkerInfoC->pCore;

    int k = -1;
    for(int j = 0; j < size; j++ ) {
        if( m_patternId == pMarkerInfo[j].id ) {
            if( k == -1 ) k = j;
            else if( pMarkerInfo[k].cf < pMarkerInfo[j].cf ) k = j;
        }
    }
	ARMarkerInfoContainer detected;
	detected.pCore = NULL;
    if( k != -1 ) {
		detected.pCore = &(pMarkerInfo[k]);
    }

	return Detect(& detected);
}

// IJSObject擾܂B
IJSObject* ARPattern::GetJSObject()
{
	return NULL;
}

// p^[܂B
HRESULT ARPattern::LoadPattern(const char* filepath)
{
	if(filepath == NULL) {
		return E_POINTER;
	}
	int patternId = arLoadPatt(filepath);

	if(patternId < 0) {
		return E_FAIL;
	}

	m_patternId = patternId;
	return S_OK;
}
