#pragma once

#include "../../js/JSPropertyWrapper.h"
#include "../../common/AbstractProperty.h"
#include "GLBitmapDump.h"

class ARWindow;
class IJSContext;
class IPatternDetector;

/**
* WindowJavaScriptbp[łB
*/
class ARJSWindow : public JSNamedProperty
{
public:

	/**
	* \z܂B
	*/
	ARJSWindow(ARWindow* pWindow, INamedProperty* pProp);

	/**
	* j܂B
	*/
	~ARJSWindow();

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* L[Cxg܂B
	*/
	HRESULT OnKeyPress(unsigned char key, int x, int y, bool* pPreventDefault);

	/**
	* p^[o̒ǉʒm܂B
	*/
	HRESULT NotifyPatternDetectorAdded(const char* name, IPatternDetector* pDetector);

protected:

	/**
	* ܂B
	*/
	virtual HRESULT InitMembers();
	
	/**
	* vpeBݒ肵܂B
	*/
	virtual HRESULT SetProperty(JSContext *cx, JSObject *obj, const char* name, jsval vp);
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);
	
	/**
	* ֐s܂B
	*/
	virtual HRESULT InvokeFunction(JSContext *cx, JSObject *obj, const char* name, uintN argc, jsval *argv, jsval *rval);

private:

	/**
	* L[Cxg𐶐܂B
	*/
	HRESULT CreateKeyEvent(unsigned char key, int x, int y, JSObject** ppObject);

	/**
	* rfI܂B
	*/
	HRESULT InitVideoImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* EBhE܂B
	*/
	HRESULT InitWindowImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* [hWno^܂B
	*/
	HRESULT AddWorldImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* XN[Lv`ۑ܂B
	*/
	HRESULT SaveImageImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* XN[Lv`Jn܂B
	*/
	HRESULT StartSaveMovieImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* XN[Lv`I܂B
	*/
	HRESULT StopSaveMovieImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* p^[XgB
	*/
	class PatternList : public AbstractArrayProperty
	{
	public:

		/**
		* \z܂B
		*/
		PatternList(ARJSWindow* pOwner);

		/**
		* j܂B
		*/
		virtual ~PatternList();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* vpeB擾܂B
		*/
		HRESULT GetPropertyCount(int* pCount);

	protected:
			
		/**
		* vpeB擾܂B
		*/
		HRESULT GetPropertyDesc(int index, PROPERTY_DESC* pDesc);
				
		/**
		* IJSObject̃vpeB擾܂B
		*/
		HRESULT GetJSObject(int index, IJSObject** ppValue);

	private:

		/**
		* I[i[ێ܂B
		*/
		ARJSWindow* m_pOwner;
	};

	/**
	* 摜_v܂B
	*/
	class ImageFileDump : public GLBitmapDump
	{
	public:

		/**
		* \z܂B
		*/
		ImageFileDump(IWindow* pWindow, JSEngineContext* pContext, const char* savePath, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~ImageFileDump();

	protected:

		/**
		* ۑp̃pX擾܂B
		*/
		virtual HRESULT GetSavePath(LONGLONG t, string& path, bool* pExit);

	private:

		/**
		* ۑppXێ܂B
		*/
		string m_savePath;

	};

	/**
	* [r[_v܂B
	*/
	class MovieFileDump : public GLBitmapDump
	{
	public:

		/**
		* \z܂B
		*/
		MovieFileDump(IWindow* pWindow, JSEngineContext* pContext, const char* prefix, const char* suffix, int bufferSize, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~MovieFileDump();

	protected:

		/**
		* ۑp̃pX擾܂B
		*/
		virtual HRESULT GetSavePath(LONGLONG t, string& path, bool* pExit);

	private:

		/**
		* ۑppXێ܂B
		*/
		string m_savePrefix;

		/**
		* ۑppXێ܂B
		*/
		string m_saveSuffix;

		/**
		* CfbNXێ܂B
		*/
		unsigned int m_iIndex;

	};
	/**
	* EBhEێ܂B
	*/
	ARWindow* m_pWindow;

	/**
	* L[Cxgێ܂B
	*/ 
	FunctionRef m_onKeyPress;

	/**
	* p^[Xgێ܂B
	*/
	PatternList* m_pPatternList;

	/**
	* [hXgێ܂B
	*/
	JSArrayRef m_worldList;

	/**
	* p^[Xgێ܂B
	*/
	JSArrayRef m_patternList;

	/**
	* _vpIuWFNgێ܂B
	*/
	MovieFileDump* m_pDump;

	/**
	* p^[oێ܂B
	*/
	map<string, IPatternDetector*> m_detectors;
};
