#pragma once
#include "../ARGraphics.h"
#include "AbstractARJSObject.h"
#include <ar/ar.h>

class ARWindow;

/**
* [gƂȂOtBbNXB
*/
class ARJSWorld :
	public ARGraphics
{
public:

	/**
	* \z܂B
	*/
	ARJSWorld(ARWindow* pWindow);

	/**
	* j܂B
	*/
	virtual ~ARJSWorld(void);

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* JavaScriptGWݒ肵܂B
	*/
	HRESULT Attach(JSEngineContext* pContext);

	/**
	* IJSObject擾܂B
	*/
	IJSObject* GetJSObject();

	/**
	* OtBbN`悵܂B
	*/
	virtual HRESULT Draw();

protected:

	/**
	* vpeB𐶐܂B
	*/
	virtual HRESULT CreateProperty(INamedProperty** ppProp);

private:
	
	/**
	* EBhEێ܂B
	*/
	ARWindow* m_pWindow;

	/**
	* ϊsێ܂B
	*/
	double m_trans[3][4];

	/**
	* ̃xNgێ܂B
	*/
    float m_lightPosition[4];

	/**
	* ێ܂B
	*/
	float m_lightAmbient[4];

	/**
	* gUێ܂B
	*/
	float m_lightDiffuse[4];

	/**
	* JavaScriptIuWFNgێ܂B
	*/
	class JSObjectImpl : public AbstractARJSObject
	{
	public:

		/**
		* \z܂B
		*/
		JSObjectImpl(ARJSWorld* pOwner, INamedProperty* pProp);

		/**
		* j܂B
		*/
		virtual ~JSObjectImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();

	protected:
		
		/**
		* o܂B
		*/
		virtual HRESULT InitMembers();
		
		/**
		* vpeBݒ肵܂B
		*/
		virtual HRESULT SetProperty(JSContext *cx, JSObject *obj, const char* name, jsval vp);
		
		/**
		* vpeB擾܂B
		*/
		virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);

	private:

		/**
		* IDݒ肵܂B
		*/
		HRESULT SetTransElement(JSContext *cx, jsuint index, jsval arrv);

		/**
		* LIuWFNgێ܂B
		*/
		ARJSWorld* m_pOwner;
	};

	/**
	* vpeB̎łB
	*/
	class WorldPropertyImpl : public GraphicsPropertyImpl
	{
	public:

		/**
		* \z܂B
		*/
		WorldPropertyImpl(ARJSWorld* pOwner);

		/**
		* j܂B
		*/
		virtual ~WorldPropertyImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();
		
		/**
		* ܂B
		*/
		virtual HRESULT Init();

	protected:
		
		/**
		* doublẽvpeB擾܂B
		*/
		virtual HRESULT GetDoubleProperty(const char* name, double* pValue);
		
		/**
		* doublẽvpeBݒ肵܂B
		*/
		virtual HRESULT SetDoubleProperty(const char* name, double value);

	protected:

		/**
		* O͂܂B
		*/
		HRESULT ParseName(const char* name, string& categoryName, string& propName);

	private:

		/**
		* o擾܂B
		*/
		HRESULT GetMember(float* pColor, const char* propName, float** ppValue);

		/**
		* I[i[ێ܂B
		*/
		ARJSWorld* m_pOwner;
	};

	/**
	* JavaScriptIuWFNgێ܂B
	*/
	JSObjectImpl* m_pJSObject;

	/**
	* qm[hێ܂B
	*/
	JSArrayRef m_childNodes;
};
