#pragma once
#include "../ARGraphics.h"
#include "../../js/JSPropertyWrapper.h"


/**
* JavaScriptIuWFNgB
*/
class AbstractARJSObject : public JSNamedProperty
{
public:

	/**
	* \z܂B
	*/
	AbstractARJSObject(ARGraphics* pOwner, INamedProperty* pProp);

	/**
	* j܂B
	*/
	virtual ~AbstractARJSObject();

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* IuWFNgt@Ng̒ǉʒm܂B
	*/
	virtual HRESULT NotifyObjectFactoryAdded(const char* name, IARGObjectFactory* pFactory);

protected:
	
	/**
	* o܂B
	*/
	virtual HRESULT InitMembers();
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);
	
	/**
	* ֐s܂B
	*/
	virtual HRESULT InvokeFunction(JSContext *cx, JSObject *obj, const char* name, uintN argc, jsval *argv, jsval *rval);

	/**
	* IuWFNgt@Ngo^܂B
	*/
	virtual HRESULT RegisterFactory(const char* name, IARGObjectFactory* pFactory);

private:

	/**
	* SolidCubeǉ܂B
	*/
	HRESULT AddSolidCubeImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* Containerǉ܂B
	*/
	HRESULT AddContainerImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* 摜f[^ǉ܂B
	*/
	HRESULT LoadImageImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* f[^ǉ܂B
	*/
	HRESULT AddTextImpl(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* vOCIuWFNgǉ܂B
	*/
	HRESULT CreateObject(JSContext *cx, JSObject *obj, IARGObjectFactory* pFactory, uintN argc, jsval *argv, jsval *rval);

	/**
	* LIuWFNgێ܂B
	*/
	ARGraphics* m_pOwner;

	/**
	* qm[hێ܂B
	*/
	JSArrayRef m_childNodes;
};
