#pragma once

#include "../../image/GLImageDump.h"
#include "../../js/IJSFunction.h"
#include "../../common/IImage.h"

class JSEngineContext;

/**
* OpenGLrbg}bvt@Co͂܂B
*/
class GLBitmapDump : public GLImageDump
{
	public:

		/**
		* \z܂B
		*/
		GLBitmapDump(IWindow* pWindow, JSEngineContext* pContext, int bufferSize, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~GLBitmapDump();

	protected:

		/**
		* obt@̓e܂B
		*/
		virtual HRESULT Process(LONGLONG t, int width, int height, unsigned char* data);

		/**
		* ۑp̃pX擾܂B
		*/
		virtual HRESULT GetSavePath(LONGLONG t, string& path, bool* pExit) = 0;

	private:

		/**
		* EBhEێ܂B
		*/
		IWindow* m_pWindow;

		/**
		* ReLXgێ܂B
		*/
		JSEngineContext* m_pContext;

		/**
		* Iǂێ܂B
		*/
		bool m_bExit;

private:

	/**
	* eXgp̉摜IuWFNgłB
	*/
	class TextureImage : public IImage
	{
	public:

		/**
		* \z܂B
		*/
		TextureImage(int width, int height, unsigned char* bgr32);

		/**
		* j܂B
		*/
		virtual ~TextureImage();

		/**
		* j܂B
		*/
		virtual void Destroy();

		/**
		* 摜ŐV̏ԂɍXV܂B
		*/
		virtual HRESULT Refresh();
		
		/**
		* 擾܂B
		*/
		virtual int GetWidth();
		
		/**
		* 擾܂B
		*/
		virtual int GetHeight();

		/**
		* Materialp̃At@l擾܂B
		*/
		virtual double GetMaterialAlpha();
		
		/**
		* sNZ̏擾܂B
		*/
		virtual HRESULT GetPixel(int x, int y, COMMON_ARGB* pARGB);

		/**
		* Dirtyǂ𔻒肵܂B
		*/
		virtual HRESULT IsDirty(bool* pDirty);

		/**
		* Dirtyǂݒ肵܂B
		*/
		virtual HRESULT SetDirty(bool dirty);

		/**
		* vpeB擾܂B
		*/
		virtual HRESULT GetProperty(INamedProperty** ppProp);

	private:

		/**
		* RGBobt@ێ܂B
		*/
		unsigned char* m_pBGR32;

		/**
		* ێ܂B
		*/
		int m_iWidth;

		/**
		* ێ܂B
		*/
		int m_iHeight;
	};

	/**
	* _vIuWFNg폜܂B
	*/
	class ImageDumpRemover : public IJSFunction
	{
	public:

		/**
		* \z܂B
		*/
		ImageDumpRemover(IWindow* pWindow, GLBitmapDump* pDump);

		/**
		* ܂B
		*/
		virtual ~ImageDumpRemover();

		/**
		* j܂B
		*/
		virtual void Destroy();

		/**
		* s܂B
		*/
		virtual HRESULT Invoke();

	private:

		/**
		* EBhEێ܂B
		*/
		IWindow* m_pWindow;

		/**
		* _vIuWFNgێ܂B
		*/
		GLBitmapDump* m_pDump;

	};

};
