#pragma once

#include "IProperty.h"

/**
* vpeB̎łB
*/
class AbstractNamedProperty : public INamedProperty
{
public:

	/**
	* \z܂B
	*/
	AbstractNamedProperty();

	/**
	* j܂B
	*/
	virtual ~AbstractNamedProperty();

	/**
	* vpeBl擾܂B
	*/
	virtual HRESULT GetPropertyValue(const char* name, IPropertyValue** ppValue);
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetPropertyCount(int* pCount);
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetPropertyName(int index, string& name);

protected:
		
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetPropertyDesc(const char* name, PROPERTY_DESC* pDesc);
	
	/**
	* ̃vpeB擾܂B
	*/
	virtual HRESULT GetDoubleProperty(const char* name, double* pValue);
	
	/**
	* ̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetDoubleProperty(const char* name, double value);
	
	/**
	* bool̃vpeB擾܂B
	*/
	virtual HRESULT GetBoolProperty(const char* name, bool* pValue);
	
	/**
	* bool̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetBoolProperty(const char* name, bool value);
	
	/**
	* int̃vpeB擾܂B
	*/
	virtual HRESULT GetIntProperty(const char* name, int* pValue);
	
	/**
	* int̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetIntProperty(const char* name, int value);
	
	/**
	* string̃vpeB擾܂B
	*/
	virtual HRESULT GetStringProperty(const char* name, string& value);
	
	/**
	* string̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetStringProperty(const char* name, const char* value);
	
	/**
	* IJSObject̃vpeB擾܂B
	*/
	virtual HRESULT GetJSObject(const char* name, IJSObject** ppValue);
	
	/**
	* IJSObject̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetJSObject(const char* name, IJSObject* pValue);

	/**
	* vpeB`܂B
	*/
	virtual HRESULT DefineProperty(const char* name, const PROPERTY_DESC* pDesc);

	/**
	* vpeB`܂B
	*/
	virtual HRESULT DefineProperty(const char* name, PROPERTY_TYPE type);

	/**
	* l̃NXB
	*/
	class ValueImpl : public IPropertyValue
	{
	public:

		/**
		* \z܂B
		*/
		ValueImpl(AbstractNamedProperty* pOwner, const char* name);

		/**
		* j܂B
		*/
		virtual ~ValueImpl();

		/**
		* j܂B
		*/
		void Release();
		
		/**
		* vpeB擾܂B
		*/
		HRESULT GetPropertyDesc(PROPERTY_DESC* pDesc);
		
		/**
		* ̃vpeB擾܂B
		*/
		HRESULT GetDoubleProperty(double* pValue);
		
		/**
		* ̃vpeBݒ肵܂B
		*/
		HRESULT SetDoubleProperty(double value);
		
		/**
		* bool̃vpeB擾܂B
		*/
		HRESULT GetBoolProperty(bool* pValue);
		
		/**
		* bool̃vpeBݒ肵܂B
		*/
		HRESULT SetBoolProperty(bool value);
		
		/**
		* int̃vpeB擾܂B
		*/
		HRESULT GetIntProperty(int* pValue);
		
		/**
		* int̃vpeBݒ肵܂B
		*/
		HRESULT SetIntProperty(int value);
		
		/**
		* string̃vpeB擾܂B
		*/
		HRESULT GetStringProperty(string& value);
		
		/**
		* string̃vpeBݒ肵܂B
		*/
		HRESULT SetStringProperty(const char* value);
		
		/**
		* IJSObject̃vpeB擾܂B
		*/
		HRESULT GetJSObject(IJSObject** ppValue);
		
		/**
		* IJSObject̃vpeBݒ肵܂B
		*/
		HRESULT SetJSObject(IJSObject* pValue);

	private:

		/**
		* I[i[ێ܂B
		*/
		AbstractNamedProperty* m_pOwner;

		/**
		* vpeBێ܂B
		*/
		string m_name;
	};

	/**
	* `ێ܂B
	*/
	map<string, PROPERTY_DESC> m_descs;

	/**
	* Oێ܂B
	*/
	vector<string> m_names;

};


/**
* vpeB̎łB
*/
class AbstractArrayProperty : public IArrayProperty
{
public:

	/**
	* \z܂B
	*/
	AbstractArrayProperty();

	/**
	* j܂B
	*/
	virtual ~AbstractArrayProperty();

	/**
	* ʒmIuWFNgݒ肵܂B
	*/
	virtual HRESULT SetNotify(IArrayPropertyNotify* pNotify);

	/**
	* vpeBl擾܂B
	*/
	virtual HRESULT GetPropertyValue(int index, IPropertyValue** ppValue);

protected:
		
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetPropertyDesc(int index, PROPERTY_DESC* pDesc);
	
	/**
	* ̃vpeB擾܂B
	*/
	virtual HRESULT GetDoubleProperty(int index, double* pValue);
	
	/**
	* ̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetDoubleProperty(int index, double value);
	
	/**
	* bool̃vpeB擾܂B
	*/
	virtual HRESULT GetBoolProperty(int index, bool* pValue);
	
	/**
	* bool̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetBoolProperty(int index, bool value);
	
	/**
	* int̃vpeB擾܂B
	*/
	virtual HRESULT GetIntProperty(int index, int* pValue);
	
	/**
	* int̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetIntProperty(int index, int value);
	
	/**
	* string̃vpeB擾܂B
	*/
	virtual HRESULT GetStringProperty(int index, string& value);
	
	/**
	* string̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetStringProperty(int index, const char* value);
	
	/**
	* IJSObject̃vpeB擾܂B
	*/
	virtual HRESULT GetJSObject(int index, IJSObject** ppValue);
	
	/**
	* IJSObject̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetJSObject(int index, IJSObject* pValue);

	/**
	* ύXʒm܂B
	*/
	HRESULT NotifyChanged();

	/**
	* l̃NXB
	*/
	class ValueImpl : public IPropertyValue
	{
	public:

		/**
		* \z܂B
		*/
		ValueImpl(AbstractArrayProperty* pOwner, int index);

		/**
		* j܂B
		*/
		virtual ~ValueImpl();

		/**
		* j܂B
		*/
		void Release();
		
		/**
		* vpeB擾܂B
		*/
		HRESULT GetPropertyDesc(PROPERTY_DESC* pDesc);
		
		/**
		* ̃vpeB擾܂B
		*/
		HRESULT GetDoubleProperty(double* pValue);
		
		/**
		* ̃vpeBݒ肵܂B
		*/
		HRESULT SetDoubleProperty(double value);
		
		/**
		* bool̃vpeB擾܂B
		*/
		HRESULT GetBoolProperty(bool* pValue);
		
		/**
		* bool̃vpeBݒ肵܂B
		*/
		HRESULT SetBoolProperty(bool value);
		
		/**
		* int̃vpeB擾܂B
		*/
		HRESULT GetIntProperty(int* pValue);
		
		/**
		* int̃vpeBݒ肵܂B
		*/
		HRESULT SetIntProperty(int value);
		
		/**
		* string̃vpeB擾܂B
		*/
		HRESULT GetStringProperty(string& value);
		
		/**
		* string̃vpeBݒ肵܂B
		*/
		HRESULT SetStringProperty(const char* value);
		
		/**
		* IJSObject̃vpeB擾܂B
		*/
		HRESULT GetJSObject(IJSObject** ppValue);
		
		/**
		* IJSObject̃vpeBݒ肵܂B
		*/
		HRESULT SetJSObject(IJSObject* pValue);

	private:

		/**
		* I[i[ێ܂B
		*/
		AbstractArrayProperty* m_pOwner;

		/**
		* CfbNXێ܂B
		*/
		int m_iIndex;
	};

	/**
	* ʒmIuWFNgێ܂B
	*/
	IArrayPropertyNotify* m_pNotify;

};
