#pragma once

/**
* vpeB̃^CvB
*/
enum PROPERTY_TYPE
{
	PROP_BOOL,
	PROP_INT,
	PROP_DOUBLE,
	PROP_NAMED,
	PROP_ARRAY,
	PROP_JSOBJECT,
	PROP_STRING
};

/**
* vpeB̐B
*/
typedef struct __tagPROPERTY_DESC
{
	enum PROPERTY_TYPE type;
}PROPERTY_DESC;

class INamedProperty;
class IArrayProperty;
class IJSObject;

/**
* vpeB̒lB
*/
class IPropertyValue
{
public:

	/**
	* j܂B
	*/
	virtual void Release() = 0;
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetPropertyDesc(PROPERTY_DESC* pDesc) = 0;
	
	/**
	* ̃vpeB擾܂B
	*/
	virtual HRESULT GetDoubleProperty(double* pValue) = 0;
	
	/**
	* ̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetDoubleProperty(double value) = 0;
	
	/**
	* bool̃vpeB擾܂B
	*/
	virtual HRESULT GetBoolProperty(bool* pValue) = 0;
	
	/**
	* bool̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetBoolProperty(bool value) = 0;
	
	/**
	* int̃vpeB擾܂B
	*/
	virtual HRESULT GetIntProperty(int* pValue) = 0;
	
	/**
	* int̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetIntProperty(int value) = 0;
	
	/**
	* string̃vpeB擾܂B
	*/
	virtual HRESULT GetStringProperty(string& value) = 0;
	
	/**
	* string̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetStringProperty(const char* value) = 0;
	
	/**
	* IJSObject̃vpeB擾܂B
	*/
	virtual HRESULT GetJSObject(IJSObject** ppValue) = 0;
	
	/**
	* IJSObject̃vpeBݒ肵܂B
	*/
	virtual HRESULT SetJSObject(IJSObject* pValue) = 0;

};

/**
* ύXMp̃C^tF[XB
*/
class IArrayPropertyNotify
{
public:

	/**
	* ύXƂʒm܂B
	*/
	virtual HRESULT NotifyChanged(IArrayProperty* pSender) = 0;
};

/**
* vpeB̃C^tF[XB
*/
class INamedProperty
{
public:

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetPropertyCount(int* pCount) = 0;
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetPropertyName(int index, string& name) = 0;

	/**
	* vpeBl擾܂B
	*/
	virtual HRESULT GetPropertyValue(const char* name, IPropertyValue** ppValue) = 0;

};

/**
* vpeB̃C^tF[XB
*/
class IArrayProperty
{
public:

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;

	/**
	* ʒmIuWFNgݒ肵܂B
	*/
	virtual HRESULT SetNotify(IArrayPropertyNotify* pNotify) = 0;
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetPropertyCount(int* pCount) = 0;

	/**
	* vpeBl擾܂B
	*/
	virtual HRESULT GetPropertyValue(int index, IPropertyValue** ppValue) = 0;

};