#pragma once

/**
* \ȒlIuWFNgłB
* ݒ̏Ԃł͎Iɑҋ@s܂B
*/
template <class T>
class SynchronizableValue
{
public:
	
	/**
	* \z܂B
	*/
	SynchronizableValue(const T& value) 
	{
		m_hStatus = S_OK;
		m_hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	};

	/**
	* j܂B
	*/
	virtual ~SynchronizableValue()
	{
		if(m_hEvent != NULL) {
			CloseHandle(m_hEvent);
			m_hEvent = NULL;
		}
	};

	/**
	* lݒ肵܂B
	*/
	virtual HRESULT Set(const T& value)
	{
		if(m_hEvent == NULL) {
			return E_UNEXPECTED;
		}
		m_hStatus = S_OK;
		m_value = value;
		SetEvent(m_hEvent);
		return S_OK;
	};

	/**
	* G[ݒ肵܂B
	*/
	virtual HRESULT SetFailed(HRESULT hStatus)
	{
		if(m_hEvent == NULL) {
			return E_UNEXPECTED;
		}
		m_hStatus = hStatus;
		SetEvent(m_hEvent);
		return S_OK;
	};

	/**
	* lNA܂B
	*/
	virtual HRESULT Clear()
	{
		if(m_hEvent == NULL) {
			return E_UNEXPECTED;
		}
		ResetEvent(m_hEvent);
		return S_OK;
	};

	/**
	* l擾܂B
	* ݒ̏ꍇ͑ҋ@܂B
	*/
	virtual HRESULT Get(T& value)
	{
		if(m_hEvent == NULL) {
			return E_UNEXPECTED;
		}
		WaitForSingleObject(m_hEvent, INFINITE);
		if(FAILED(m_hStatus)) {
			return m_hStatus;
		}
		value = m_value;
		return S_OK;
	};

	/**
	* l擾܂Bҋ@̒l𒼐ڎ擾܂B
	*/
	virtual HRESULT GetNoWait(T& value)
	{
		if(m_hEvent == NULL) {
			return E_UNEXPECTED;
		}
		value = m_value;
		return S_OK;
	};

protected:

	/**
	* Cxgnhێ܂B
	*/
	HANDLE m_hEvent;

	/**
	* ʂێ܂B
	*/
	HRESULT m_hStatus;

	/**
	* lێ܂B
	*/
	T m_value;

};
