#include "StdAfx.h"
#include "AbstractImage.h"

// \z܂B
AbstractImage::AbstractImage(int width, int height)
{
	m_iWidth = width;
	m_iHeight = height;
	m_dAlpha = 1.0;
	m_pProp = NULL;
	m_bDirty = true;
}

// j܂B
AbstractImage::~AbstractImage()
{
	if(m_pProp != NULL) {
		m_pProp->Destroy();
		m_pProp = NULL;
	}
}

// 摜ŐV̏ԂɍXV܂B
HRESULT AbstractImage::Refresh()
{
	return S_OK;
}

// 擾܂B
int AbstractImage::GetWidth()
{
	return m_iWidth;
}

// 擾܂B
int AbstractImage::GetHeight()
{
	return m_iHeight;
}

// Materialp̃At@l擾܂B
double AbstractImage::GetMaterialAlpha()
{
	return m_dAlpha;
}

// Dirtyǂ𔻒肵܂B
HRESULT AbstractImage::IsDirty(bool* pDirty)
{
	if(pDirty == NULL) {
		return E_POINTER;
	}
	*pDirty = m_bDirty;
	return S_OK;
}

// Dirtyǂݒ肵܂B
HRESULT AbstractImage::SetDirty(bool dirty)
{
	m_bDirty = dirty;
	return S_OK;
}

// vpeB擾܂B
HRESULT AbstractImage::GetProperty(INamedProperty** ppProp)
{
	if(ppProp == NULL) {
		return E_POINTER;
	}
	if(m_pProp == NULL) {
		m_pProp = CreateProperty();

		HRESULT hr = m_pProp->Init();
		if(FAILED(hr)) {
			return hr;
		}
	}

	*ppProp = m_pProp;
	return S_OK;
}

// vpeBIuWFNg𐶐܂B
AbstractImage::PropertyImpl* AbstractImage::CreateProperty()
{
	return new PropertyImpl(this);
}

// \z܂B
AbstractImage::PropertyImpl::PropertyImpl(AbstractImage* pOwner)
{
	m_pOwner = pOwner;
}

// j܂B
AbstractImage::PropertyImpl::~PropertyImpl()
{
	m_pOwner = NULL;
}

// j܂B
void AbstractImage::PropertyImpl::Destroy()
{
	delete this;
}

// vpeB擾܂B
HRESULT AbstractImage::PropertyImpl::Init()
{
	HRESULT hr = S_OK;

	hr = DefineProperty("alpha", PROP_DOUBLE);
	if(FAILED(hr)) {
		return hr;
	}

	return S_OK;
}

// ̃vpeB擾܂B
HRESULT AbstractImage::PropertyImpl::GetDoubleProperty(const char* name, double* pValue)
{
	if(pValue == NULL) {
		return E_POINTER;
	}
	string sname = name;
	if(sname == "alpha") {
		*pValue = m_pOwner->m_dAlpha;
		return S_OK;
	}else{
		return AbstractNamedProperty::GetDoubleProperty(name, pValue);
	}
}

// ̃vpeBݒ肵܂B
HRESULT AbstractImage::PropertyImpl::SetDoubleProperty(const char* name, double value)
{
	string sname = name;
	if(sname == "alpha") {
		m_pOwner->m_dAlpha = value;
		m_pOwner->m_bDirty = true;
		return S_OK;
	}else{
		return AbstractNamedProperty::SetDoubleProperty(name, value);
	}
}
