
#define __JPEGCORE_C__
#include "JpegCore.h"
#include <setjmp.h>

#ifdef __cplusplus
extern "C" {
#endif

// ǂݍ
HRESULT jpegRead(FILE* pFile, READ_INFO* pReadInfo);

#ifdef __cplusplus
}
#endif

struct my_error_mgr {
	struct jpeg_error_mgr pub;
	jmp_buf setjmp_buffer;
};

typedef struct my_error_mgr * my_error_ptr;

METHODDEF(void)
my_error_exit (j_common_ptr cinfo)
{
	my_error_ptr myerr = (my_error_ptr) cinfo->err;
	(*cinfo->err->output_message) (cinfo);
	longjmp(myerr->setjmp_buffer, 1);
}

// ǂݍ
HRESULT jpegRead(FILE* pFile, READ_INFO* pReadInfo)
{
	struct jpeg_decompress_struct cinfo;
	struct my_error_mgr jerr;
	int row_stride = 0;
	JSAMPARRAY buffer = NULL;
	HRESULT hr = S_OK;

	ZeroMemory(& cinfo, sizeof(cinfo));
	ZeroMemory(& jerr, sizeof(jerr));
	
	cinfo.err = jpeg_std_error(&jerr.pub);
	jerr.pub.error_exit = my_error_exit;
	
	if (setjmp(jerr.setjmp_buffer)) {
		jpeg_destroy_decompress(&cinfo);
		fclose(pFile);
		pFile = NULL;
		return E_FAIL;
	}
	
	// WJp̍\̂̍쐬
	jpeg_create_decompress(&cinfo);
	
	jpeg_stdio_src(&cinfo, pFile);
	
	jpeg_read_header(&cinfo, TRUE);
	jpeg_start_decompress(&cinfo);
	
	row_stride = cinfo.output_width * cinfo.output_components;
	
	buffer = (*cinfo.mem->alloc_sarray)((j_common_ptr) &cinfo,
							JPOOL_IMAGE,
							row_stride,
							1);

	while (cinfo.output_scanline < cinfo.output_height) {
		jpeg_read_scanlines(&cinfo, buffer, 1);
		hr = (pReadInfo->pReadScanLine)(pReadInfo->pPrivData, & cinfo, buffer, cinfo.output_scanline);
		if(FAILED(hr)) {
			break;
		}
	}
	
	jpeg_finish_decompress(&cinfo);
	jpeg_destroy_decompress(&cinfo);
	
	fclose(pFile);
	pFile = NULL;
	return S_OK;
}

