#pragma once

#include "../ar/IImageLoader.h"
#include "AbstractImage.h"
#include "../common/WorkerThread.h"
#define XMD_H
#define NEED_FAR_POINTERS
#include <jconfig.h>
#include <jpeglib.h>

/**
* JPEG[_łB
*/
class JpgImageLoader : public IImageLoader
{
public:

	/**
	* \z܂B
	*/
	JpgImageLoader();

	/**
	* j܂B
	*/
	virtual ~JpgImageLoader();

	/**
	* j܂B
	*/
	void Destroy();

	/**
	* ftHgTCYݒ肵܂B
	*/
	virtual HRESULT SetDefaultSize(int width, int height);
	
	/**
	* 摜ǂݍ݂܂B
	*/
	virtual HRESULT Load(const char* path, IImageLoaderNotify* pNotify);
	
	/**
	* 摜ǂݍ݂܂B
	*/
	virtual HRESULT Load(ISource* pSource, IImageLoaderNotify* pNotify);

private:
	
	/**
	* [J[̎B
	*/
	class WorkerImpl : public IWorker
	{
	public:

		/**
		* \z܂B
		*/
		WorkerImpl(const char* path, IImageLoaderNotify* pNotify);
		
		/**
		* j܂B
		*/
		virtual ~WorkerImpl();
		
		/**
		* j܂B
		*/
		virtual void Destroy();
		
		/**
		* s܂B
		* G[̓XbĥȂ΂Ȃ܂B
		*/
		virtual HRESULT Invoke();

	private:

		/**
		* ǂݍ݂܂B
		*/
		HRESULT Read(IImage** ppImage);

		/**
		* obt@Rs[܂B
		*/
		HRESULT CreateBuffer(const struct jpeg_decompress_struct* pInfo);

		/**
		* obt@Rs[܂B
		*/
		HRESULT ReadScanLine(const struct jpeg_decompress_struct* pInfo, const JSAMPARRAY pSrc, int y);

		/**
		* obt@Rs[܂B
		*/
		static HRESULT SReadScanLine(void* pPrivData, const struct jpeg_decompress_struct* pInfo, const JSAMPARRAY pSrc, int y);
	
		/**
		* pXێ܂B
		*/
		string m_path;

		/**
		* ʒmIuWFNgێ܂B
		*/
		IImageLoaderNotify* m_pNotify;

		/**
		* obt@ێ܂B
		*/
		unsigned char* m_pBuffer;

		/**
		* ێ܂B
		*/
		unsigned int m_iWidth;

		/**
		* ێ܂B
		*/
		unsigned int m_iHeight;

	};

	/**
	* Pȉ摜IuWFNgB
	*/
	class ImageImpl : public AbstractImage
	{
	public:

		/**
		* \z܂B
		*/
		ImageImpl(int width, int height, unsigned char* pBuf);

		/**
		* j܂B
		*/
		virtual ~ImageImpl();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* sNZ擾܂B
		*/
		HRESULT GetPixel(int x, int y, COMMON_ARGB* pARGB);

	private:

		/**
		* obt@ێ܂B
		*/
		unsigned char* m_pBuf;
	};

	/**
	* XbhB
	*/
	WorkerThread m_workerThread;

};
