#pragma once

#include "../ar/IImageLoader.h"
#include "../common/WorkerThread.h"
#include "AbstractImage.h"
#include <png.h>

/**
* PNG[_łB
*/
class PngImageLoader : public IImageLoader
{
public:

	/**
	* \z܂B
	*/
	PngImageLoader();

	/**
	* j܂B
	*/
	virtual ~PngImageLoader();

	/**
	* j܂B
	*/
	void Destroy();

	/**
	* ftHgTCYݒ肵܂B
	*/
	virtual HRESULT SetDefaultSize(int width, int height);
	
	/**
	* 摜ǂݍ݂܂B
	*/
	virtual HRESULT Load(const char* path, IImageLoaderNotify* pNotify);
	
	/**
	* 摜ǂݍ݂܂B
	*/
	virtual HRESULT Load(ISource* pSource, IImageLoaderNotify* pNotify);

private:
	
	/**
	* [J[̎B
	*/
	class WorkerImpl : public IWorker
	{
	public:

		/**
		* \z܂B
		*/
		WorkerImpl(ISource* pSource, IImageLoaderNotify* pNotify);
		
		/**
		* j܂B
		*/
		virtual ~WorkerImpl();
		
		/**
		* j܂B
		*/
		virtual void Destroy();
		
		/**
		* s܂B
		* G[̓XbĥȂ΂Ȃ܂B
		*/
		virtual HRESULT Invoke();

	private:

		/**
		* ǂݍ݂܂B
		*/
		static void PngReadFunc(png_struct *pPng, png_bytep buf, png_size_t size);

		/**
		* ǂݍ݂܂B
		*/
		HRESULT Read(IImage** ppImage);
	
		/**
		* \[Xێ܂B
		*/
		ISource* m_pSource;

		/**
		* ʒmIuWFNgێ܂B
		*/
		IImageLoaderNotify* m_pNotify;

	};

	/**
	* Pȉ摜IuWFNgB
	*/
	class ImageImpl : public AbstractImage
	{
	public:

		/**
		* \z܂B
		*/
		ImageImpl(int width, int height, unsigned char* pBuf);

		/**
		* j܂B
		*/
		virtual ~ImageImpl();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* sNZ擾܂B
		*/
		HRESULT GetPixel(int x, int y, COMMON_ARGB* pARGB);

	private:

		/**
		* obt@ێ܂B
		*/
		unsigned char* m_pBuf;

	};

	/**
	* XbhB
	*/
	WorkerThread m_workerThread;

};
