#pragma once

#include "../ar/IImageLoader.h"
#include "AbstractImage.h"
#include "../common/WorkerThread.h"

/**
* eLXg[_łB
*/
class TextLoader : public IImageLoader
{
public:

	/**
	* \z܂B
	*/
	TextLoader(HWND hOwnerWnd);

	/**
	* j܂B
	*/
	virtual ~TextLoader();

	/**
	* j܂B
	*/
	void Destroy();

	/**
	* ftHgTCYݒ肵܂B
	*/
	virtual HRESULT SetDefaultSize(int width, int height);
	
	/**
	* 摜ǂݍ݂܂B
	*/
	virtual HRESULT Load(const char* path, IImageLoaderNotify* pNotify);
	
	/**
	* 摜ǂݍ݂܂B
	*/
	virtual HRESULT Load(ISource* pSource, IImageLoaderNotify* pNotify);

private:
	
	/**
	* [J[̎B
	*/
	class WorkerImpl : public IWorker
	{
	public:

		/**
		* \z܂B
		*/
		WorkerImpl(HWND hOwnerWnd, IImageLoaderNotify* pNotify);
		
		/**
		* j܂B
		*/
		virtual ~WorkerImpl();
		
		/**
		* j܂B
		*/
		virtual void Destroy();
		
		/**
		* s܂B
		* G[̓XbĥȂ΂Ȃ܂B
		*/
		virtual HRESULT Invoke();

	private:

		/**
		* I[i[EBhEێ܂B
		*/
		HWND m_hOwnerWnd;

		/**
		* ʒmIuWFNgێ܂B
		*/
		IImageLoaderNotify* m_pNotify;

	};

	/**
	* Pȉ摜IuWFNgB
	*/
	class ImageImpl : public AbstractImage
	{
	public:

		/**
		* \z܂B
		*/
		ImageImpl(HWND hOwnerWnd);

		/**
		* j܂B
		*/
		virtual ~ImageImpl();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* 摜ŐV̏ԂɍXV܂B
		*/
		HRESULT Refresh();

		/**
		* sNZ擾܂B
		*/
		HRESULT GetPixel(int x, int y, COMMON_ARGB* pARGB);

	protected:

		/**
		* vpeBIuWFNg𐶐܂B
		*/
		virtual PropertyImpl* CreateProperty();

	private:

		/**
		* eNX`XV܂B
		*/
		HRESULT RefreshTexture();

		/**
		* tHgXV܂B
		*/
		HRESULT RefreshFont(HDC hDC);

		/**
		* uVXV܂B
		*/
		HRESULT RefreshBrush(HDC hDC);

		/**
		* Fێ܂B
		*/
		typedef struct __tagTEXT_COLOR {
			double r;
			double g;
			double b;
		}TEXT_COLOR;

		/**
		* Fϊ܂B
		*/
		COLORREF GetColorRef(const TEXT_COLOR* pColor);

		/**
		* vpeBłB
		*/
		class TextPropertyImpl : public PropertyImpl
		{
		public:

			/**
			* \z܂B
			*/
			TextPropertyImpl(ImageImpl* pOwner);

			/**
			* j܂B
			*/
			virtual ~TextPropertyImpl();

			/**
			* j܂B
			*/
			virtual void Destroy();

			/**
			* ܂B
			*/
			virtual HRESULT Init();

		protected:
			
			/**
			* int̃vpeB擾܂B
			*/
			virtual HRESULT GetIntProperty(const char* name, int* pValue);
			
			/**
			* int̃vpeBݒ肵܂B
			*/
			virtual HRESULT SetIntProperty(const char* name, int value);
			
			/**
			* string̃vpeB擾܂B
			*/
			virtual HRESULT GetStringProperty(const char* name, string& value);
			
			/**
			* string̃vpeBݒ肵܂B
			*/
			virtual HRESULT SetStringProperty(const char* name, const char* value);
			
			/**
			* ̃vpeB擾܂B
			*/
			virtual HRESULT GetDoubleProperty(const char* name, double* pValue);
			
			/**
			* ̃vpeBݒ肵܂B
			*/
			virtual HRESULT SetDoubleProperty(const char* name, double value);
			
			/**
			* bool̃vpeB擾܂B
			*/
			virtual HRESULT GetBoolProperty(const char* name, bool* pValue);
			
			/**
			* bool̃vpeBݒ肵܂B
			*/
			virtual HRESULT SetBoolProperty(const char* name, bool value);

		private:

			/**
			* I[i[ێ܂B
			*/
			ImageImpl* m_pOwner;
		};

		/**
		* I[i[EBhEێ܂B
		*/
		HWND m_hOwnerWnd;

		/**
		* obt@ێ܂B(BGRA)
		*/
		unsigned char* m_pBuf;

		/**
		* ̕ێ܂B
		*/
		int m_iNextWidth;

		/**
		* ̍ێ܂B
		*/
		int m_iNextHeight;

		/**
		* ̃eLXgێ܂B
		*/
		string m_nextText;

		/**
		* ύXꂽǂێ܂B
		*/
		bool m_bChanged;

		/**
		* tHgێ܂B
		*/
		HFONT m_hFont;

		/**
		* uVێ܂B
		*/
		HBRUSH m_hBrush;

		/**
		* tHg̍łB(sNZP)
		*/
		int m_iFontHeightPx;

		/**
		* C^bNǂێ܂B
		*/
		bool m_bFontItalic;

		/**
		* tHg̑ێ܂B
		*/
		int m_iFontWeight;

		/**
		* tHgێ܂B
		*/
		string m_fontName;

		/**
		* tHgFێ܂B
		*/
		TEXT_COLOR m_fontColor;

		/**
		* wiFێ܂B
		*/
		TEXT_COLOR m_bgColor;

	};

	/**
	* XbhB
	*/
	WorkerThread m_workerThread;

	/**
	* I[i[EBhẼnhB
	*/
	HWND m_hOwnerWnd;
};
