#include "StdAfx.h"
#include "JSEngineFactory.h"
#include "JSEngine.h"

#include <jsapi.h>

const unsigned int DEFAULT_MAX_BYTES = 8L * 1024L * 1024L;

// \z܂B
JSEngineFactory::JSEngineFactory(void)
{
	m_bCreated = false;
}

// j܂B
JSEngineFactory::~JSEngineFactory(void)
{
	if(m_bCreated) {
		JS_ShutDown();
		m_bCreated = false;
	}
}

// ܂B
HRESULT JSEngineFactory::Create(IJSEngine** ppEngine)
{
	if(ppEngine == NULL) {
		return E_POINTER;
	}

	HRESULT hr = S_OK;
	JSEngine* pNewEngine = new JSEngine(DEFAULT_MAX_BYTES, & hr);
	if(pNewEngine == NULL) {
		return E_OUTOFMEMORY;
	}
	if(FAILED(hr)) {
		pNewEngine->Destroy();
		pNewEngine = NULL;
		*ppEngine = NULL;
		return hr;
	}

	m_bCreated = true;
	*ppEngine = pNewEngine;
	return S_OK;
}