#pragma once

#include "JSObjectWrapper.h"
#include "IJSContext.h"
#include "IJSFunction.h"
#include "../common/WorkerThread.h"

/**
* JavaScript GlobalIuWFNgB
*/
class JSGlobalObject : public JSObjectWrapper
{
public:

	/**
	* \z܂B
	*/
	JSGlobalObject();

	/**
	* j܂B
	*/
	virtual ~JSGlobalObject();

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* ʒmIuWFNgݒ肵܂B
	*/
	HRESULT SetNotify(IJSContextNotify* pNotify);

	/**
	* vpeB`܂B
	*/
	HRESULT DefineProperty(const char* name, IJSObject* pObject);

	/**
	* G[ʒm܂B
	*/
	HRESULT NotifyError(const char* message, const char* filename, unsigned int lineno, const char* token);

	/**
	* G[󂯎ǂ𔻒肵܂B
	*/
	HRESULT IsErrorReceived(bool* pReceived);

	/**
	* G[󂯎ǂNA܂B
	*/
	HRESULT ClearErrorReceived();

protected:

	/**
	* ܂B
	*/
	virtual HRESULT Init(JSContext* pContext, JSObject* pObject);

	/**
	* GetPrivate\bh̎B
	*/
	JSOW_GET_PRIVATE_DECL(JSGlobalObject);

private:

	/**
	* ^C}[\񂵂܂B
	*/
	HRESULT ReserveTimer(long* pId);

	/**
	* ^C}[s܂B
	*/
	HRESULT InvokeTimer(long id, bool* pEnabled);

	/**
	* ֐`B
	*/
	JSOW_FUNCTION_DECL(JSGlobalObject, SAlert, AlertImpl);

	/**
	* ֐`B
	*/
	JSOW_FUNCTION_DECL(JSGlobalObject, SPrintLine, PrintLineImpl);

	/**
	* ^C}[ݒ֐B
	*/
	JSOW_FUNCTION_DECL(JSGlobalObject, SSetTimeout, SetTimeoutImpl);

	/**
	* ^C}[Zbg֐B
	*/
	JSOW_FUNCTION_DECL(JSGlobalObject, SClearTimeout, ClearTimeoutImpl);

	/**
	* vpeB`B
	*/
	JSOW_PROPERTY_DECL(JSGlobalObject, SSetter, SetProperty, SGetter, GetProperty);

	/**
	* vpeBێ܂B
	*/
	map<string, IJSObject*> m_props; 

	/**
	* ʒmIuWFNgݒ肵܂B
	*/
	IJSContextNotify* m_pNotify;

	/**
	* ^C}ێ܂B
	*/
	map<long, bool> m_timers;

	/**
	* [J[ێ܂B
	*/
	WorkerThread m_workerThread;

	/**
	* G[oێ܂B
	*/
	int m_iErrorReceived;

	/**
	* ^C}[ҋ@XbhłB
	*/
	class TimerWait : public IWorker
	{
	public:

		/**
		* \z܂B
		*/
		TimerWait(JSGlobalObject* pOwner, long id, long timeout, FunctionRef* pFunc);

		/**
		* j܂B
		*/
		virtual ~TimerWait();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* s܂B
		*/
		HRESULT Invoke();

	private:

		/**
		* I[i[ێ܂B
		*/
		JSGlobalObject* m_pOwner;

		/**
		* IDێ܂B
		*/
		long m_lId;

		/**
		* ^CAEgێ܂B
		*/
		long m_lTimeout;

		/**
		* R[obNێ܂B
		*/
		FunctionRef* m_pFunc;
	};

	/**
	* ^C}[ʒmłB
	*/
	class TimerNotify : public IJSFunction
	{
	public:

		/**
		* \z܂B
		*/
		TimerNotify(JSGlobalObject* pOwner, long id, FunctionRef* pFunc);

		/**
		* j܂B
		*/
		virtual ~TimerNotify();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* s܂B
		*/
		HRESULT Invoke();

	private:

		/**
		* I[i[ێ܂B
		*/
		JSGlobalObject* m_pOwner;

		/**
		* IDێ܂B
		*/
		long m_lId;

		/**
		* R[obNێ܂B
		*/
		FunctionRef* m_pFunc;
	};

};
