#pragma once

#include "JSObjectWrapper.h"

#define MAX_NATIVE	100


#define JSMEM_FUNCTION_DECL(Index, ClassName, SFunctionName, IFunctionName) \
JSOW_FUNCTION_DECL(ClassName, ##SFunctionName_##Index, ##IFunctionName_##Index)

#define JSMEM_FUNCTION_DEF(Index, ClassName, SFunctionName, IFunctionName) \
JSOW_FUNCTION_DEF(ClassName, ##SFunctionName_##Index, ##IFunctionName_##Index) \
HRESULT ClassName::##IFunctionName_##Index(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) \
{ \
	return InvokeFunc(cx, obj, Index, argc, argv, rval); \
}


#define JSMEM_FUNCTION_INIT(Index, ClassName, SFunctionName, IFunctionName) \
	ClassName::##SFunctionName_##Index

/**
* oǗRNVłB
*/
class JSMemberCollection : public JSObjectWrapper
{
public:

	/**
	* \z܂B
	*/
	JSMemberCollection(const char* className);

	/**
	* j܂B
	*/
	virtual ~JSMemberCollection();

	/**
	* ܂B
	*/
	virtual HRESULT Init(JSContext* pContext, JSObject* pObject);

	/**
	* GetPrivate\bh̎B
	*/
	JSOW_GET_PRIVATE_DECL(JSMemberCollection);

	/**
	* ꏊ擾܂B
	*/
	virtual void GetLocation(JSContext* cx, const char* className, const char* implName, jsval idval, string& location);

protected:
	
	/**
	* o܂B
	*/
	virtual HRESULT InitMembers() = 0;
	
	/**
	* vpeBݒ肵܂B
	*/
	virtual HRESULT SetProperty(JSContext *cx, JSObject *obj, const char* name, jsval vp);
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);
	
	/**
	* ֐s܂B
	*/
	virtual HRESULT InvokeFunction(JSContext *cx, JSObject *obj, const char* name, uintN argc, jsval *argv, jsval *rval);
	
	/**
	* vpeB`܂B
	*/
	HRESULT DefineProperty(const char* name, bool readonly);
	
	/**
	* ֐`܂B
	*/
	HRESULT DefineFunction(const char* name, int minArgs);
	
private:

	/**
	* vpeB`B
	*/
	JSOW_PROPERTY_DECL(JSMemberCollection, SSetProp, SetPropImpl, SGetProp, GetPropImpl);

	/**
	* JSNativeւ̎QƂ擾܂B
	*/
	HRESULT GetNativeRef(const char* name, JSNative* pFuncRef);
	
	/**
	* ֐s܂B
	*/
	HRESULT InvokeFunc(JSContext *cx, JSObject *obj, UINT index, uintN argc, jsval *argv, jsval *rval);
	
	/**
	* JSNativeւ̎QƂێ܂B
	*/
	static JSNative m_nativeRefs[MAX_NATIVE];

	/**
	* JSNative`܂B
	*/
	JSMEM_FUNCTION_DECL(0, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(1, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(2, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(3, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(4, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(5, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(6, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(7, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(8, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(9, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(10, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(11, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(12, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(13, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(14, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(15, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(16, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(17, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(18, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(19, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(20, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(21, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(22, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(23, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(24, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(25, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(26, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(27, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(28, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(29, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(30, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(31, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(32, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(33, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(34, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(35, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(36, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(37, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(38, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(39, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(40, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(41, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(42, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(43, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(44, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(45, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(46, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(47, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(48, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(49, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(50, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(51, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(52, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(53, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(54, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(55, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(56, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(57, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(58, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(59, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(60, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(61, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(62, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(63, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(64, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(65, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(66, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(67, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(68, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(69, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(70, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(71, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(72, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(73, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(74, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(75, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(76, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(77, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(78, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(79, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(80, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(81, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(82, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(83, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(84, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(85, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(86, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(87, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(88, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(89, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(90, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(91, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(92, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(93, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(94, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(95, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(96, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(97, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(98, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);
	JSMEM_FUNCTION_DECL(99, JSMemberCollection, SInvokeFunc, InvokeFuncImpl);

	/**
	* ֐̃XgłB
	*/
	vector<string> m_functionNames;

	/**
	* NXłB
	*/
	string m_className;
	
	/**
	* GW̃ReLXgێ܂B
	*/
	JSContext* m_pJSContext;
	
	/**
	* GW̃IuWFNgێ܂B
	*/
	JSObject* m_pJSObject;
	
};
