#pragma once

#include <jsapi.h>
#include "JSEngineContext.h"
#include "IJSObject.h"

/**
* GetPrivate\bh̐錾B
*/
#define JSOW_GET_PRIVATE(cx, obj, ClassName) \
	((ClassName*) JS_GetPrivate(cx, obj))

/**
* SpiderMonkeyĂяo\Ȋ֐錾B
*/
#define JSOW_FUNCTION_DECL(ClassName, SFunctionName, IFunctionName) \
	static JSBool SFunctionName(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval); \
	\
	HRESULT IFunctionName(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

/**
* SpiderMonkeyĂяo\Ȋ֐`B
*/
#define JSOW_FUNCTION_DEF(ClassName, SFunctionName, IFunctionName) \
JSBool ClassName::SFunctionName(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) \
{ \
	ClassName* pObj = JSOW_GET_PRIVATE(cx, obj, ClassName); \
	HRESULT hr = pObj->IFunctionName(cx, obj, argc, argv, rval); \
	if(FAILED(hr)) { \
		string location; \
		pObj->GetLocation(cx, #ClassName, #IFunctionName, JSVAL_NULL, location); \
		JSObjectWrapper::ReportError(cx, location.c_str(), hr); \
		return JS_FALSE; \
	} \
	return JS_TRUE; \
}

/**
* SpiderMonkeyĂяo\Ȋ֐QƁB
*/
#define JSOW_FUNCTION_REF(ClassName, SFunctionName) \
	ClassName::SFunctionName

/**
* SpiderMonkeyĂяo\ȃvpeB錾B
*/
#define JSOW_PROPERTY_DECL_0(ClassName, SFunctionName, IFunctionName) \
	static JSBool SFunctionName(JSContext *cx, JSObject *obj, jsval idval, jsval *vp); \
	\
	HRESULT IFunctionName(JSContext *cx, JSObject *obj, jsval idval, jsval *vp);

/**
* SpiderMonkeyĂяo\ȃvpeB錾B
*/
#define JSOW_PROPERTY_DECL(ClassName, SSetterName, ISetterName, SGetterName, IGetterName) \
	JSOW_PROPERTY_DECL_0(ClassName, SSetterName, ISetterName); \
	JSOW_PROPERTY_DECL_0(ClassName, SGetterName, IGetterName);

/**
* SpiderMonkeyĂяo\ȃvpeB`B
*/
#define JSOW_PROPERTY_DEF_0(ClassName, SFunctionName, IFunctionName) \
JSBool ClassName::SFunctionName(JSContext *cx, JSObject *obj, jsval idval, jsval *vp) \
{ \
	ClassName* pObj = JSOW_GET_PRIVATE(cx, obj, ClassName); \
	HRESULT hr = pObj->IFunctionName(cx, obj, idval, vp); \
	if(FAILED(hr)) { \
		string location; \
		pObj->GetLocation(cx, #ClassName, #IFunctionName, idval, location); \
		JSObjectWrapper::ReportError(cx, location.c_str(), hr); \
		return JS_FALSE; \
	} \
	return JS_TRUE; \
}

/**
* SpiderMonkeyĂяo\ȃvpeB`B
*/
#define JSOW_PROPERTY_DEF(ClassName, SSetterName, ISetterName, SGetterName, IGetterName) \
	JSOW_PROPERTY_DEF_0(ClassName, SSetterName, ISetterName); \
	JSOW_PROPERTY_DEF_0(ClassName, SGetterName, IGetterName);

/**
* SpiderMonkeyĂяo\ȃvpeBQƁB
*/
#define JSOW_PROPERTY_REF(ClassName, SFunctionName) \
	ClassName::SFunctionName

/**
* GetPrivate\bh̐錾B
*/
#define JSOW_GET_PRIVATE_DECL(ClassName) \
	virtual void* GetPrivate() { \
		return (ClassName*) this; \
	}

  

/**
* JavaScriptIuWFNg̒ۃNXB
*/
class JSObjectWrapper : public IJSObject
{
public:

	/**
	* jsval當o܂B
	*/
	static HRESULT GetValueToString(JSEngineContext* pContext, jsval val, string& str);

	/**
	* G[񍐂܂B
	*/
	static void ReportError(JSContext* cx, const char* location, HRESULT hr);

	/**
	* \z܂B
	*/
	JSObjectWrapper();

	/**
	* j܂B
	*/
	virtual ~JSObjectWrapper();

	/**
	* JavaScriptGWƃIuWFNgݒ肵܂B
	*/
	virtual HRESULT Attach(JSEngineContext* pContext, JSObject* pObject);

	/**
	* JavaScriptGWƃIuWFNgݒ肵܂B
	*/
	virtual HRESULT Attach(JSEngineContext* pContext, JSObject* pObject, bool addRoot);

	/**
	* IuWFNg̎̂擾܂B
	*/
	JSObject* GetCore();

	/**
	* ꏊ擾܂B
	*/
	virtual void GetLocation(JSContext* cx, const char* className, const char* implName, jsval idval, string& location);

	/**
	* IuWFNgɊ֘AtĂf[^擾܂B
	*/
	virtual HRESULT GetData(const char* name, void** ppv);

protected:

	/**
	* ܂B
	*/
	virtual HRESULT Init(JSContext* pContext, JSObject* pObject) = 0;

	/**
	* privateIuWFNg擾܂B
	*/
	virtual void* GetPrivate() = 0;

	/**
	* jsval當o܂B
	*/
	HRESULT GetValueToString(jsval val, string& str);

	/**
	* l̔z𐶐܂B
	*/
	HRESULT CreateDoubleArray(double* pValues, int size, JSObject** ppArray);

	/**
	* JSObjectƂ̃IuWFNg̊֌W܂B
	*/
	virtual void Detach();

	/**
	* ReLXgێ܂B
	*/
	JSEngineContext* m_pContext;

	/**
	* ֐ւ̎QƁB
	*/
	class FunctionRef
	{
	public:

		/**
		* \z܂B
		*/
		FunctionRef();

		/**
		* j܂B
		*/
		virtual ~FunctionRef();

		/**
		* ܂B
		*/
		HRESULT Init(JSEngineContext* pContext, IJSObject* pOwner);

		/**
		* s܂B
		*/
		HRESULT InvokeSync(jsval* argv, int argc, jsval* rval);

		/**
		* ֐ݒ肵܂B
		*/
		HRESULT Set(jsval func);

		/**
		* ֐擾܂B
		*/
		HRESULT Get(jsval* pFunc);

	private:

		/**
		* ReLXgێ܂B
		*/
		JSEngineContext* m_pContext;

		/**
		* I[i[ێ܂B
		*/
		IJSObject* m_pOwner;

		/**
		* ֐ێ܂B
		*/
		jsval* m_pFunction;
	};

private:

	/**
	* IuWFNgێ܂B
	*/
	JSObject* m_pObject;
};
