#pragma once
#include "../common/IProperty.h"
#include "JSMemberCollection.h"

/**
* vpeBłB
*/
class JSNamedProperty : public JSMemberCollection
{
public:

	/**
	* \z܂B
	*/
	JSNamedProperty(INamedProperty* pProp);

	/**
	* \z܂B
	*/
	JSNamedProperty(const char* prefix, INamedProperty* pProp);

	/**
	* j܂B
	*/
	virtual ~JSNamedProperty();

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* v~eBuȒlݒ肵܂B
	*/
	static HRESULT SetPrimitiveValue(JSContext* cx, JSObject* obj, IPropertyValue* pTarget, jsval val);

	/**
	* v~eBuȒl擾܂B
	*/
	static HRESULT GetPrimitiveValue(JSContext* cx, JSObject* obj, IPropertyValue* pTarget, jsval* pval);

protected:
	
	/**
	* o܂B
	*/
	virtual HRESULT InitMembers();
	
	/**
	* vpeBݒ肵܂B
	*/
	virtual HRESULT SetProperty(JSContext *cx, JSObject *obj, const char* name, jsval vp);
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);

private:

	/**
	* O͂܂B
	*/
	HRESULT ParseName(const char* fullName, string& propName, bool* pPrimitive);

	/**
	* IuWFNgݒ肵܂B
	*/
	HRESULT SetValue(JSContext* cx, JSObject* pObj);

	/**
	* vtBbNXێ܂B
	*/
	string m_prefix;

	/**
	* vpeBێ܂B
	*/
	INamedProperty* m_pProp;
	
	/**
	* qvpeBێ܂B
	*/
	map<string,JSNamedProperty*> m_props;
	
};

/**
* vpeBłB
*/
class JSArrayProperty : public JSObjectWrapper
{
public:

	/**
	* \z܂B
	*/
	JSArrayProperty(IArrayProperty* pProp);

	/**
	* j܂B
	*/
	virtual ~JSArrayProperty();

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* JavaScriptGWƃIuWFNgݒ肵܂B
	*/
	HRESULT Attach(JSEngineContext* pContext, JSObject* pObject);

	/**
	* GetPrivate\bh̎B
	*/
	JSOW_GET_PRIVATE_DECL(JSArrayProperty);

	/**
	* vpeB擾p̃\bh錾B
	*/
	JSOW_PROPERTY_DECL(JSArrayProperty, SSetProp, SetPropImpl, SGetProp, GetPropImpl);

protected:
	
	/**
	* o܂B
	*/
	virtual HRESULT Init(JSContext* cx, JSObject* obj);

private:

	/**
	* Ώۂ擾܂B
	*/
	HRESULT GetTarget(JSContext* cx, jsval idval, int* pTarget);

	/**
	* vpeBێ܂B
	*/
	IArrayProperty* m_pProp;
	
};

/**
* zւ̎QƂǗ郆[eBeBNXB
*/
class JSArrayRef
{
public:

	/**
	* \z܂B
	*/
	JSArrayRef();

	/**
	* j܂B
	*/
	virtual ~JSArrayRef();

	/**
	* ݒ肵܂B
	*/
	HRESULT Attach(IArrayProperty* pProp, JSEngineContext* pContext, IJSObject* pOwner);

	/**
	* JSIuWFNg擾܂B
	*/
	HRESULT GetJSObject(IJSObject** ppObj);

private:

	/**
	* vpeBێ܂B
	*/
	IArrayProperty* m_pProp;

	/**
	* JSIuWFNgێ܂B
	*/
	JSArrayProperty* m_pJSProp;
};