
#include "ARGBaseUnknown.h"
#include "IARGPatternDetector.h"
#include "ARGTypeInfo.h"

/**
* IuWFNg̒ۃNXłB
*/
class ARGBasePattern : public ARGBaseUnknown, public IARGPattern, public IDispatch
{
public:

	/**
	* \z܂B
	*/
	ARGBasePattern()
	{
		m_pTypeInfo = NULL;
	};

	/**
	* j܂B
	*/
	virtual ~ARGBasePattern()
	{
		if(m_pTypeInfo != NULL) {
			m_pTypeInfo->Release();
			m_pTypeInfo = NULL;
		}
	};

	DECLARE_BASE_UNKNOWN;

	/**
	* C^tF[X擾܂B
	*/
	virtual STDMETHODIMP QueryInterface(const IID& riid, void** ppv)
	{
		if(ppv == NULL) {
			return E_POINTER;
		}

		if(riid == IID_IARGPattern) {
			*ppv = static_cast<IARGPattern*>(this);
			AddRef();
			return S_OK;
		}else if(riid == IID_IDispatch) {
			*ppv = static_cast<IDispatch*>(this);
			AddRef();
			return S_OK;
		}

		return ARGBaseUnknown::QueryInterface(riid, ppv);
	};

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP GetTypeInfoCount(unsigned int *pCount)
	{
		if(pCount == NULL) {
			return E_POINTER;
		}
		*pCount = 1;
		return S_OK;
	};

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo **ppTInfo)
	{
		if(ppTInfo == NULL) {
			return E_POINTER;
		}
		if(iTInfo != 0) {
			return E_INVALIDARG;
		}
		if(m_pTypeInfo == NULL) {
			return E_UNEXPECTED;
		}

		*ppTInfo = m_pTypeInfo;
		m_pTypeInfo->AddRef();

		return S_OK;
	};

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP GetIDsOfNames(REFIID riid, OLECHAR **rgszNames, unsigned int cNames, LCID lcid, DISPID *rgDispId)
	{
		if(rgszNames == NULL || rgDispId == NULL) {
			return E_POINTER;
		}
		if(m_pTypeInfo == NULL) {
			return E_UNEXPECTED;
		}

		MEMBERID* pMemIds = new MEMBERID[cNames];
		HRESULT hr = m_pTypeInfo->GetIDsOfNames(rgszNames, cNames, pMemIds);

		if(hr == S_OK) {
			for(UINT i = 0; i < cNames; i ++) {
				rgDispId[i] = pMemIds[i];
			}
		}

		delete[] pMemIds;
		pMemIds = NULL;
		return hr;
	};

protected:

	/**
	* ^Cvێ܂B
	*/
	ARGTypeInfo* m_pTypeInfo;

};
