#pragma once

#include <objbase.h>

#define DECLARE_BASE_UNKNOWN \
	virtual STDMETHODIMP_(ULONG) AddRef(void) \
	{ \
		return ARGBaseUnknown::AddRef(); \
	}; \
	virtual STDMETHODIMP_(ULONG) Release(void) \
	{ \
		return ARGBaseUnknown::Release(); \
	};

/**
* IUnknown̒ۃNXłB
*/
class ARGBaseUnknown : public IUnknown
{
public:

	/**
	* \z܂B
	*/
	ARGBaseUnknown() 
	{
		m_cRef = 1;
	}

	/**
	* j܂B
	*/
	virtual ~ARGBaseUnknown() 
	{
		;
	}

	/**
	* IUnknown̎łB
	*/
	virtual STDMETHODIMP QueryInterface(REFIID riid, LPVOID *ppv)
	{
		if(ppv == NULL) {
			return E_POINTER;
		}
		*ppv = NULL;
		if(riid == IID_IUnknown) {
			*ppv = static_cast<IUnknown*>(this);
		} else {
			return E_NOINTERFACE;
		}
		reinterpret_cast<IUnknown*>(*ppv)->AddRef();
		return S_OK;		
	};

	/**
	* IUnknown̎łB
	*/
	virtual STDMETHODIMP_(ULONG) AddRef(void)
	{
		return InterlockedIncrement(&m_cRef);
	};

	/**
	* IUnknown̎łB
	*/
	virtual STDMETHODIMP_(ULONG) Release(void)
	{
		LONG res = InterlockedDecrement(&m_cRef);
		if(0 == res) {
			delete this;
		}
		return res;
	};

private:

	/**
	* QƃJE^ێ܂B
	*/
	LONG m_cRef;

};
