
#include "ARGBaseUnknown.h"
#include "IARGPluginEnvironment.h"
#include "ARGMutex.h"
#include "ARGCritSection.h"

/**
* [J[̒ۃNXłB
*/
class ARGBaseWorker : public ARGBaseUnknown, public IARGWorker
{
public:

	/**
	* jҋ@܂B
	*/
	static void WaitForDestroy(HANDLE hExitEvent)
	{
		WaitForSingleObject(hExitEvent, INFINITE);
		CloseHandle(hExitEvent);
		hExitEvent = NULL;
	}

	/**
	* \z܂B
	*/
	ARGBaseWorker()
	{
		m_bContinue = true;
		m_hExitEvent = NULL;
	};

	/**
	* j܂B
	*/
	virtual ~ARGBaseWorker()
	{
		if(m_hExitEvent != NULL) {
			SetEvent(m_hExitEvent);
		}
	};

	DECLARE_BASE_UNKNOWN;

	/**
	* C^tF[X擾܂B
	*/
	virtual STDMETHODIMP QueryInterface(const IID& riid, void** ppv)
	{
		if(ppv == NULL) {
			return E_POINTER;
		}

		if(riid == IID_IARGWorker) {
			*ppv = static_cast<IARGWorker*>(this);
			AddRef();
			return S_OK;
		}

		return ARGBaseUnknown::QueryInterface(riid, ppv);
	};

	/**
	* ~܂B
	*/
	virtual HRESULT Stop(HANDLE* hExitEvent)
	{
		if(hExitEvent == NULL) {
			return E_POINTER;
		}
		m_hExitEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
		*hExitEvent = m_hExitEvent;
		{
			ARGCritSection cs(& m_continueMutex);
			m_bContinue = false;
		}
		return S_OK;
	}

protected:

	/**
	* s邩ǂێ܂B
	*/
	virtual bool IsContinue()
	{
		ARGCritSection cs(& m_continueMutex);
		return m_bContinue;
	}
	
private:

	/**
	* continuetOpMutexێ܂B
	*/
	ARGMutex m_continueMutex;

	/**
	* continuetOێ܂B
	*/
	bool m_bContinue;

	/**
	* ICxgێ܂B
	*/
	HANDLE m_hExitEvent;

};
