#include "StdAfx.h"
#include "DefaultARGPluginEnvironment.h"

// IuWFNg𐶐܂B
HRESULT CreateDefaultARGPluginEnvironment(IARGPluginEnvironment** ppEnv)
{
	if(ppEnv == NULL) {
		return E_POINTER;
	}
	*ppEnv = new DefaultARGPluginEnvironment();
	return S_OK;
}

// \z܂B
DefaultARGPluginEnvironment::DefaultARGPluginEnvironment()
{
}

// j܂B
DefaultARGPluginEnvironment::~DefaultARGPluginEnvironment()
{
}

// C^tF[X擾܂B
STDMETHODIMP DefaultARGPluginEnvironment::QueryInterface(const IID& riid, void** ppv)
{
	if(ppv == NULL) {
		return E_POINTER;
	}

	if(riid == IID_IARGPluginEnvironment) {
		*ppv = static_cast<IARGPluginEnvironment*>(this);
		AddRef();
		return S_OK;
	}

	return ARGBaseUnknown::QueryInterface(riid, ppv);
}

// pX擾܂B
STDMETHODIMP DefaultARGPluginEnvironment::GetRealPath(const char* relativePath, char* absolutePath, int maxLen, int* pLen)
{
	if(relativePath == NULL || pLen == NULL) {
		return E_POINTER;
	}
	return E_NOTIMPL;
}

// [J[s܂B
STDMETHODIMP DefaultARGPluginEnvironment::InvokeWorker(IARGWorker* pWorker)
{
	if(pWorker == NULL) {
		return E_POINTER;
	}
	HRESULT hr = S_OK;
	WorkerWrapper* pWWorker = new WorkerWrapper(pWorker, & hr);
	if(FAILED(hr)) {
		delete pWWorker;
		pWWorker = NULL;
		return hr;
	}

	m_workerThread.Start(pWWorker);
	return S_OK;
}

// vpeBǉ܂B
STDMETHODIMP DefaultARGPluginEnvironment::AddProperty(const char* name, IDispatch* pDisp)
{
	if(name == NULL || pDisp == NULL) {
		return E_POINTER;
	}
	return E_NOTIMPL;
}

// IuWFNgt@Ngǉ܂B
STDMETHODIMP DefaultARGPluginEnvironment::AddObjectFactory(const char* name, IARGObjectFactory* pObjectFactory)
{
	if(name == NULL || pObjectFactory == NULL) {
		return E_POINTER;
	}
	return E_NOTIMPL;
}

// p^[oǉ܂B
STDMETHODIMP DefaultARGPluginEnvironment::AddPatternDetector(const char* name, IARGPatternDetector* pPatternDetector)
{
	if(name == NULL || pPatternDetector == NULL) {
		return E_POINTER;
	}
	return E_NOTIMPL;
}

// R\[ɕo͂܂B
STDMETHODIMP DefaultARGPluginEnvironment::PrintConsole(const char* text)
{
	if(text == NULL) {
		return E_POINTER;
	}
	return S_OK;
}

// \z܂B
DefaultARGPluginEnvironment::WorkerWrapper::WorkerWrapper(IARGWorker* pWorker, HRESULT* phr)
{
	m_pWorker = NULL;
	if(pWorker == NULL) {
		*phr = E_POINTER;
		return;
	}
	m_pWorker = pWorker;
	m_pWorker->AddRef();
}

// j܂B
DefaultARGPluginEnvironment::WorkerWrapper::~WorkerWrapper()
{
	if(m_pWorker != NULL) {
		m_pWorker->Release();
		m_pWorker = NULL;
	}
}

// j܂B
void DefaultARGPluginEnvironment::WorkerWrapper::Destroy()
{
	delete this;
}

// s܂B
HRESULT DefaultARGPluginEnvironment::WorkerWrapper::Invoke()
{
	if(m_pWorker == NULL) {
		return E_UNEXPECTED;
	}
	return m_pWorker->Invoke();
}
