#pragma once

#include "ARGBaseUnknown.h"
#include "IARGPluginEnvironment.h"
#include "../common/WorkerThread.h"

/**
* IuWFNg𐶐܂B
*/
DLL_DECL HRESULT CreateDefaultARGPluginEnvironment(IARGPluginEnvironment** ppEnv);

/**
* ftHg̃vOC̎łB
*/
class DefaultARGPluginEnvironment : public ARGBaseUnknown, public IARGPluginEnvironment
{
public:

	/**
	* \z܂B
	*/
	DefaultARGPluginEnvironment();

	/**
	* j܂B
	*/
	~DefaultARGPluginEnvironment();

	DECLARE_BASE_UNKNOWN;

	/**
	* C^tF[X擾܂B
	*/
	STDMETHODIMP QueryInterface(const IID& riid, void** ppv);

	/**
	* pX擾܂B
	*/
	virtual STDMETHODIMP GetRealPath(const char* relativePath, char* absolutePath, int maxLen, int* pLen);

	/**
	* [J[s܂B
	*/
	virtual STDMETHODIMP InvokeWorker(IARGWorker* pWorker);

	/**
	* vpeBǉ܂B
	*/
	virtual STDMETHODIMP AddProperty(const char* name, IDispatch* pDisp);

	/**
	* IuWFNgt@Ngǉ܂B
	*/
	virtual STDMETHODIMP AddObjectFactory(const char* name, IARGObjectFactory* pObjectFactory);

	/**
	* p^[oǉ܂B
	*/
	virtual STDMETHODIMP AddPatternDetector(const char* name, IARGPatternDetector* pPatternDetector);

	/**
	* R\[ɕo͂܂B
	*/
	virtual STDMETHODIMP PrintConsole(const char* text);

private:

	/**
	* Worker̃bp[łB
	*/
	class WorkerWrapper : public IWorker
	{
	public:

		/**
		* \z܂B
		*/
		WorkerWrapper(IARGWorker* pWorker, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~WorkerWrapper();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* s܂B
		*/
		HRESULT Invoke();

	private:

		IARGWorker* m_pWorker;
	};

	/**
	* [J[Xbhێ܂B
	*/
	WorkerThread m_workerThread;

};
