#include "StdAfx.h"
#include "AbstractWindow.h"
#include "../common/CritSection.h"

// \z܂B
AbstractWindow::AbstractWindow()
{
	m_pNotify = NULL;
}

// j܂B
AbstractWindow::~AbstractWindow()
{
	m_pNotify = NULL;
	for(vector<IWindowGLHook*>::size_type i = 0; i < m_hooks.size(); i ++) {
		IWindowGLHook* pHook = m_hooks[i];
		pHook->Destroy();
	}
	m_hooks.clear();
}

// eEBhEnhݒ肵܂B
HRESULT AbstractWindow::SetParent(HWND hWnd)
{
	return E_NOTIMPL;
}

// ʒmIuWFNgݒ肵܂B
HRESULT AbstractWindow::SetNotify(IWindowNotify* pNotify)
{
	m_pNotify = pNotify;
	return S_OK;
}

// GLp̃tbNǉ܂B
HRESULT AbstractWindow::AddGLHook(IWindowGLHook* pHook)
{
	if(pHook == NULL) {
		return E_POINTER;
	}
	CritSection cs(& m_hookMutex);
	m_hooks.push_back(pHook);
	return S_OK;
}

// GLp̃tbN폜܂B
HRESULT AbstractWindow::RemoveGLHook(IWindowGLHook* pHook)
{
	if(pHook == NULL) {
		return E_POINTER;
	}
	CritSection cs(& m_hookMutex);
	for(vector<IWindowGLHook*>::iterator it = m_hooks.begin(); it != m_hooks.end(); it ++) {
		if(*it == pHook) {
			m_hooks.erase(it);
			return S_OK;
		}
	}
	return S_FALSE;
}

// R\[ɏoȂ܂B
HRESULT AbstractWindow::PrintLine(const char* line)
{
	cout << "INFO: " << line << "\n";
	return S_OK;
}

// A[g\Ȃ܂B
HRESULT AbstractWindow::Alert(const char* message)
{
	cout << "ALERT: " << message << "\n";
	return S_OK;
}

// Xe[^XbZ[W\Ȃ܂B
HRESULT AbstractWindow::SetStatus(const char* status)
{
	cout << "STATUS: " << status << "\n";
	return S_OK;
}

// ݂̏|[g܂B
HRESULT AbstractWindow::ReportStatus(ostream* pOut)
{
	// ݂͉Ȃ
	return S_OK;
}

// `ݒ肵܂B
HRESULT AbstractWindow::SetRect(int x, int y, int width, int height)
{
	return E_NOTIMPL;
}

// `擾܂B
HRESULT AbstractWindow::GetRect(int* pX, int* pY, int* pWidth, int* pHeight)
{
	return E_NOTIMPL;
}

// ǂݍݗpGLReLXgJn܂B
HRESULT AbstractWindow::BeginGLLoading()
{
	return E_NOTIMPL;
}

// ǂݍݗpGLReLXgI܂B
HRESULT AbstractWindow::EndGLLoading()
{
	return E_NOTIMPL;
}

// `̑OłB
HRESULT AbstractWindow::NotifyPreDraw()
{
	CritSection cs(& m_hookMutex);
	for(vector<IWindowGLHook*>::iterator it = m_hooks.begin(); it != m_hooks.end(); it ++) {
		IWindowGLHook* pHook = *it;
		HRESULT hr = pHook->OnPreDraw();
		if(FAILED(hr)) {
			return hr;
		}
	}
	return S_OK;
}

// `̌㏈łB
HRESULT AbstractWindow::NotifyPostDraw()
{
	CritSection cs(& m_hookMutex);
	for(vector<IWindowGLHook*>::iterator it = m_hooks.begin(); it != m_hooks.end(); it ++) {
		IWindowGLHook* pHook = *it;
		HRESULT hr = pHook->OnPostDraw();
		if(FAILED(hr)) {
			return hr;
		}
	}
	return S_OK;
}

