#pragma once

#include "AbstractWindow.h"
#include "../common/Mutex.h"
#include "../common/SynchronizableValue.h"

/**
* EBhE̒ۂłB
*/
class Win32Window : public AbstractWindow
{
public:

	/**
	* ܂B
	*/
	static void Init(int* argc, char **argv);
	
	/**
	* \z܂B
	*/
	Win32Window();
	
	/**
	* j܂B
	*/
	virtual ~Win32Window();

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* eEBhEnhݒ肵܂B
	*/
	virtual HRESULT SetParent(HWND hWnd);

	/**
	* EBhE𐶐܂B
	*/
	virtual HRESULT Create(int width, int height);

	/**
	* C[vJn܂B
	*/
	virtual HRESULT RunMainLoop();

	/**
	* ĕ`悵܂B
	*/
	virtual HRESULT Redraw();

	/**
	* EBhE܂B
	*/
	virtual HRESULT Close();

	/**
	* `ݒ肵܂B
	*/
	virtual HRESULT SetRect(int x, int y, int width, int height);

	/**
	* `擾܂B
	*/
	virtual HRESULT GetRect(int* pX, int* pY, int* pWidth, int* pHeight);
	
	/**
	* ǂݍݗpGLReLXgJn܂B
	*/
	virtual HRESULT BeginGLLoading();

	/**
	* ǂݍݗpGLReLXgI܂B
	*/
	virtual HRESULT EndGLLoading();

private:

	/**
	* bZ[W܂B
	*/
	static LRESULT CALLBACK WindowProc0(HWND hWnd, UINT nMessage, WPARAM wParam, LPARAM lParam);

	/**
	* bZ[W܂B
	*/
	LRESULT CALLBACK WindowProc(UINT nMessage, WPARAM wParam, LPARAM lParam);

	/**
	* OpenGL܂B
	*/
	HRESULT InitGL(HWND hWnd);

	/**
	* OpenGLJn܂B
	*/
	HRESULT BeginGL();

	/**
	* OpenGLI܂B
	*/
	HRESULT EndGL();

	/**
	* G[I܂B
	*/
	LRESULT ReturnByError(HRESULT hr);

	/**
	* L[Cxg܂B
	*/
	LRESULT OnKeyEvent(unsigned char key, int x, int y);

	/**
	* \Ȃ܂B
	*/
	LRESULT OnPaint();

	/**
	* ꂽꍇ̏łB
	*/
	LRESULT OnCreate(HWND hWnd);

	/**
	* jꍇ̏łB
	*/
	LRESULT OnDestroy();

	/**
	* C[v܂B
	*/
	LRESULT OnMainLoop();

	/**
	* TCYύX̏Ȃ܂B
	*/
	LRESULT OnSize(int width, int height);

	/**
	* L[̏Ȃ܂B
	*/
	LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);

	/**
	* L[̏Ȃ܂B
	*/
	LRESULT OnKeyUp(WPARAM wParam, LPARAM lParam);

	/**
	* G[ꍇ̏B
	*/
	static void DefaultError(HRESULT hr);

	/**
	* ݂̃EBhEێ܂B
	*/
	static Win32Window* m_pCurrentWindow;
	
	/**
	* ^Cgێ܂B
	*/
	static string m_title;

	/**
	* EBhEnhێ܂B
	*/
	HWND m_hWnd;
	
	/**
	* eEBhEnhێ܂B
	*/
	HWND m_hParentWnd;

	/**
	* GLpnhێ܂B
	*/
	HGLRC m_hGLRC;

	/**
	* GLpnhێ܂B
	*/
	SynchronizableValue<HGLRC> m_hGLRCLoading;

	/**
	* bێ܂B
	*/
	DWORD m_iPrevMS;

	/**
	* ς݂ǂێ܂B
	*/
	bool m_bCreated;

	/**
	* ^C}[ID
	*/
	unsigned int m_iTimerID;

	/**
	* L[ꂽƂێ܂B
	*/
	bool m_bKeyDown;

	/**
	* ݂̃foCXReLXgێ܂B
	*/
	HDC m_hCurrentDC;

	/**
	* ݂̃foCXReLXgێ܂B
	*/
	HDC m_hCurrentDCLoading;

	/**
	* GL̓sh߂MutexłB
	*/
	Mutex m_glMutex;

	/**
	* ^C}[̃lXg񐔂ێ܂B
	*/
	int m_iNestTimer;
};


