#pragma once

#include "../BaseTypes.h"
#include "../io/d3dxhelper.h"
#include "../io/common.h"
#include "../io/MMD_IO.h"
#include "../io/clsPMDFile.h"
#include "../io/clsVMDFile.h"
#include "MMDVertexList.h"

/**
* \Ǘp̃NXłB
*/
class MMDMorp
{
private:

	class Motion;

	/**
	* IuWFNgmr܂B
	*/
	static bool Less(const Motion* pLeft, const Motion* pRight);

public:

	/**
	* \z܂B
	*/
	MMDMorp(const PMD_MORP_RECORD* pMorp, const PMD_MORP_RECORD* pMorpBase, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~MMDMorp();

	/**
	* [Vj܂B
	*/
	HRESULT ClearMotion();

	/**
	* O擾܂B
	*/
	HRESULT GetName(string& name);

	/**
	* őt[擾܂B
	*/
	HRESULT GetMaxFrame(int* pFrameNo);

	/**
	* ǉΏۂǂ𔻒肵܂B
	*/
	HRESULT IsTarget(const VMD_MORP_RECORD* pMotion);

	/**
	* [Vǉ܂B
	*/
	HRESULT AddMotion(const VMD_MORP_RECORD* pMotion);

	/**
	* [V܂B
	*/
	HRESULT PrepareMotion();

	/**
	* [V𒸓_ɓKp܂B
	*/
	HRESULT ApplyMotion(float elapsedFrame, MMD_VERTEX_DESC** pOriginalVertexes);

	/**
	* _ɓKp܂B
	*/
	HRESULT Set(MMD_VERTEX_DESC** pOriginalVertexes);

	/**
	* _Blend[hœKp܂B
	*/
	HRESULT Blend(MMD_VERTEX_DESC** pOriginalVertexes, float weight);

private:

	/**
	* [V܂B
	*/
	HRESULT FindMotion(float elapsedTime, Motion** ppBegin, Motion** ppEnd, float* pOffset);

	/**
	* \ێ܂B
	*/
	PMD_MORP_RECORD m_morp;

	/**
	* [Vێ܂B
	*/
	vector<Motion*> m_motions;

	/**
	* [VłB
	*/
	class Motion
	{
	public:

		/**
		* \z܂B
		*/
		Motion(const VMD_MORP_RECORD* pMotion, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~Motion();

		/**
		* t[ԍ擾܂B
		*/
		HRESULT GetFrameNo(int* pFrameNo) const;

		/**
		* Kp擾܂B
		*/
		HRESULT GetRate(float* pRate);

	private:

		/**
		* [Vێ܂B
		*/
		VMD_MORP_RECORD m_motion;

	};
};
