#pragma once

#include "../BaseTypes.h"
#include "../io/clsPMDFile.h"

class MMDBone;

/**
* _f[^\܂B
*/
typedef struct {		
	MMD_VECTOR3 point;	// _z (x, y, z)
	MMD_VECTOR3 normal;	// @z (x, y, z)
	MMD_VECTOR2 uv;		// UVz (u, v)
} MMD_VERTEX_TEXUSE;

/**
* _̊Ǘ\̂\܂B
*/
typedef struct {
	MMD_VERTEX_TEXUSE original;
	MMD_VERTEX_TEXUSE faced;
	MMD_VERTEX_TEXUSE current;
	MMDBone* pBones[2];
	float bweight;
}MMD_VERTEX_DESC;

/**
* _XgłB
*/
class MMDVertexList
{
public:

	/**
	* \z܂B
	*/
	MMDVertexList(const PMD_VERTEX_CHUNK* pVertexes, const PMD_INDEX_CHUNK* pIndices, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~MMDVertexList();

	/**
	* _擾܂B
	*/
	HRESULT GetVertexDescs(MMD_VERTEX_DESC*** pppDescs);

	/**
	* _擾܂B
	*/
	HRESULT GetVertexDesc(int index, MMD_VERTEX_DESC** ppDescs);

	/**
	* CfbNXɑΉ钸_擾܂B
	*/
	HRESULT GetVertex(int index, PMD_VERTEX_RECORD* pVertex);

	/**
	* XLjOsXV܂B
	*/
	HRESULT UpdateSkinning();

	/**
	* _Zbg܂B
	*/
	HRESULT ResetVertexes();

private:

	/**
	* _obt@𐶐܂B
	*/
	HRESULT CreateVertexDesc();

	/**
	* _ێ܂B
	*/
	PMD_VERTEX_CHUNK m_vertexes;

	/**
	* CfbNXێ܂B
	*/
	PMD_INDEX_CHUNK m_indices;

	/**
	* _ێ܂B
	*/
	MMD_VERTEX_DESC** m_pVertexes;

};
